

// This C++ file was created by SanEditor

#include "Atomic/ClientSAN/ClientSANSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         ClientSANSAN Constructor             
******************************************************************/


ClientSANSAN::ClientSANSAN(){


  Activity* InitialActionList[5]={
    &IA_Assign_Client_ID, //0
    &IA_Next_Operation_Details, //1
    &TI_Next_Operation, //2
    &IA_End_Trans, //3
    &IA_Begin_Trans  // 4
  };

  BaseGroupClass* InitialGroupList[5]={
    (BaseGroupClass*) &(TI_Next_Operation), 
    (BaseGroupClass*) &(IA_End_Trans), 
    (BaseGroupClass*) &(IA_Begin_Trans), 
    (BaseGroupClass*) &(IA_Assign_Client_ID), 
    (BaseGroupClass*) &(IA_Next_Operation_Details)
  };

  Start_Clients = new Place("Start_Clients" ,0);
  Client_ID = new Place("Client_ID" ,0);
  Number_of_Clients = new Place("Number_of_Clients" ,GV_Number_of_Clients_and_Trans);
  Begin_Trans = new Place("Begin_Trans" ,1);
  Next_Operation = new Place("Next_Operation" ,0);
  Next_Operation_Details_1 = new Place("Next_Operation_Details_1" ,0);
  End_Trans = new Place("End_Trans" ,0);
  Request_Operation_Client_1 = new Place("Request_Operation_Client_1" ,0);
  Execute_Transaction = new Place("Execute_Transaction" ,0);
  BaseStateVariableClass* InitialPlaces[9]={
    Start_Clients,  // 0
    Client_ID,  // 1
    Number_of_Clients,  // 2
    Begin_Trans,  // 3
    Next_Operation,  // 4
    Next_Operation_Details_1,  // 5
    End_Trans,  // 6
    Request_Operation_Client_1,  // 7
    Execute_Transaction   // 8
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("ClientSAN", 9, InitialPlaces, 
                        0, InitialROPlaces, 
                        5, InitialActionList, 5, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[19][2]={ 
    {1,0}, {2,0}, {5,1}, {1,1}, {4,1}, {7,1}, {8,1}, {6,1}, {4,2}, 
    {7,2}, {1,2}, {8,2}, {5,2}, {1,3}, {6,3}, {3,3}, {1,4}, {3,4}, 
    {8,4}
  };
  for(int n=0;n<19;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[10][2]={ 
    {1,0}, {2,0}, {5,1}, {0,1}, {4,2}, {0,2}, {7,2}, {6,3}, {3,4}, 
    {0,4}
  };
  for(int n=0;n<10;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<5;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void ClientSANSAN::CustomInitialization() {

}
ClientSANSAN::~ClientSANSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void ClientSANSAN::assignPlacesToActivitiesInst(){
  IA_Assign_Client_ID.Client_ID = (Place*) LocalStateVariables[1];
  IA_Assign_Client_ID.Number_of_Clients = (Place*) LocalStateVariables[2];
  IA_Next_Operation_Details.Next_Operation_Details_1 = (Place*) LocalStateVariables[5];
  IA_Next_Operation_Details.Start_Clients = (Place*) LocalStateVariables[0];
  IA_Next_Operation_Details.Client_ID = (Place*) LocalStateVariables[1];
  IA_Next_Operation_Details.Next_Operation = (Place*) LocalStateVariables[4];
  IA_Next_Operation_Details.Request_Operation_Client_1 = (Place*) LocalStateVariables[7];
  IA_Next_Operation_Details.Execute_Transaction = (Place*) LocalStateVariables[8];
  IA_Next_Operation_Details.End_Trans = (Place*) LocalStateVariables[6];
}
void ClientSANSAN::assignPlacesToActivitiesTimed(){
  TI_Next_Operation.Next_Operation = (Place*) LocalStateVariables[4];
  TI_Next_Operation.Start_Clients = (Place*) LocalStateVariables[0];
  TI_Next_Operation.Request_Operation_Client_1 = (Place*) LocalStateVariables[7];
  TI_Next_Operation.Client_ID = (Place*) LocalStateVariables[1];
  TI_Next_Operation.Execute_Transaction = (Place*) LocalStateVariables[8];
  TI_Next_Operation.Next_Operation_Details_1 = (Place*) LocalStateVariables[5];
  IA_End_Trans.End_Trans = (Place*) LocalStateVariables[6];
  IA_End_Trans.Client_ID = (Place*) LocalStateVariables[1];
  IA_End_Trans.Begin_Trans = (Place*) LocalStateVariables[3];
  IA_Begin_Trans.Begin_Trans = (Place*) LocalStateVariables[3];
  IA_Begin_Trans.Start_Clients = (Place*) LocalStateVariables[0];
  IA_Begin_Trans.Client_ID = (Place*) LocalStateVariables[1];
  IA_Begin_Trans.Execute_Transaction = (Place*) LocalStateVariables[8];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================IA_Assign_Client_IDActivity========================*/


ClientSANSAN::IA_Assign_Client_IDActivity::IA_Assign_Client_IDActivity(){
  ActivityInitialize("IA_Assign_Client_ID",3,Instantaneous , RaceEnabled, 2,2, false);
}

void ClientSANSAN::IA_Assign_Client_IDActivity::LinkVariables(){
  Client_ID->Register(&Client_ID_Mobius_Mark);
  Number_of_Clients->Register(&Number_of_Clients_Mobius_Mark);
}

bool ClientSANSAN::IA_Assign_Client_IDActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Client_ID->Mark()==0)&&(Number_of_Clients->Mark()!=0)));
  return NewEnabled;
}

double ClientSANSAN::IA_Assign_Client_IDActivity::Weight(){ 
  return 1;
}

bool ClientSANSAN::IA_Assign_Client_IDActivity::ReactivationPredicate(){ 
  return false;
}

bool ClientSANSAN::IA_Assign_Client_IDActivity::ReactivationFunction(){ 
  return false;
}

double ClientSANSAN::IA_Assign_Client_IDActivity::SampleDistribution(){
  return 0;
}

double* ClientSANSAN::IA_Assign_Client_IDActivity::ReturnDistributionParameters(){
    return NULL;
}

int ClientSANSAN::IA_Assign_Client_IDActivity::Rank(){
  return 1;
}

BaseActionClass* ClientSANSAN::IA_Assign_Client_IDActivity::Fire(){
  Client_ID->Mark()=Number_of_Clients->Mark();
Number_of_Clients->Mark()=Number_of_Clients->Mark()-1;
  return this;
}

/*======================IA_Next_Operation_DetailsActivity========================*/


ClientSANSAN::IA_Next_Operation_DetailsActivity::IA_Next_Operation_DetailsActivity(){
  ActivityInitialize("IA_Next_Operation_Details",4,Instantaneous , RaceEnabled, 6,2, false);
}

void ClientSANSAN::IA_Next_Operation_DetailsActivity::LinkVariables(){
  Next_Operation_Details_1->Register(&Next_Operation_Details_1_Mobius_Mark);
  Start_Clients->Register(&Start_Clients_Mobius_Mark);
  Client_ID->Register(&Client_ID_Mobius_Mark);
  Next_Operation->Register(&Next_Operation_Mobius_Mark);
  Request_Operation_Client_1->Register(&Request_Operation_Client_1_Mobius_Mark);
  Execute_Transaction->Register(&Execute_Transaction_Mobius_Mark);
  End_Trans->Register(&End_Trans_Mobius_Mark);
}

bool ClientSANSAN::IA_Next_Operation_DetailsActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Next_Operation_Details_1->Mark()==1)&&(Start_Clients->Mark()==1)));
  return NewEnabled;
}

double ClientSANSAN::IA_Next_Operation_DetailsActivity::Weight(){ 
  return 1;
}

bool ClientSANSAN::IA_Next_Operation_DetailsActivity::ReactivationPredicate(){ 
  return false;
}

bool ClientSANSAN::IA_Next_Operation_DetailsActivity::ReactivationFunction(){ 
  return false;
}

double ClientSANSAN::IA_Next_Operation_DetailsActivity::SampleDistribution(){
  return 0;
}

double* ClientSANSAN::IA_Next_Operation_DetailsActivity::ReturnDistributionParameters(){
    return NULL;
}

int ClientSANSAN::IA_Next_Operation_DetailsActivity::Rank(){
  return 1;
}

BaseActionClass* ClientSANSAN::IA_Next_Operation_DetailsActivity::Fire(){
  Next_Operation_Details_1->Mark()=0;

/* Are there any more operations to be performed? */
bool result = Next_Operation_Method(Client_ID->Mark());

if(GV_debug_flag==23)
{
    cerr << "Next_Operation_Method.cpp:  \"result\" is " << result << " for client " << Client_ID->Mark() << endl;
}

if(result)
{
   Next_Operation->Mark()=1;

   if(GV_debug_flag==23)
   {
      std::cerr << "Next_Operation_Method.cpp: This transaction will continue since this Client " << Client_ID->Mark() <<" has enabled Next_Operation Timed Activity" << std::endl;
      std::cerr << "Next_Operation_Method.cpp: The value of Request_Operation_Client_1->Mark() is " << Request_Operation_Client_1->Mark() << endl;
      std::cerr << "Next_Operation_Method.cpp: The value of Execute_Transaction->Mark() is " << Execute_Transaction->Mark() << endl;
   }
 
}else
{
      if(GV_debug_flag==23)
      {
         cerr << "Next_Operation_Method.cpp: This transaction will end since \"result\" is " << result << " for client " << Client_ID->Mark() << endl;
      }

      End_Trans->Mark()=1;
      
      if(GV_debug_flag==23)
      {
         std::cerr << "DIDERO_PC:ClientSAN : This Client " << Client_ID->Mark() <<" has enbaled the End_Trans Activity" << std::endl;
      }  
}

/***** Send Trace data ******/
/* Format:: Location 1: Location 2: Location_ID : Origin : Destination : Trans_ID : Trans_Type : Operation_ID : Operation-type : Time-stamp */

std::stringstream trace_data_stream;

trace_data_stream << std::string(" IG_Next_Operation_Details ") << std::string("Client ") << Client_ID->Mark() << std::string(" Server Client ") << Unbounded_Trans_ID[Client_ID->Mark()] << std::string(" ")  << (ClientObjects[Client_ID->Mark() - 1])->get_Trans_type_names((ClientObjects[Client_ID->Mark() - 1])->get_Trans_Profile_ID()) << std::string(" ") << ClientObjects[Client_ID->Mark() - 1]->get_Trans_Profile_oper_ID() << std::string(" ") << (ClientObjects[Client_ID->Mark()-1]->get_Oper_Exec_Status()) << std::string(" ") << BaseModelClass::LastActionTime << std::string("\n");

if(GV_debug_flag==23)
{
   cerr << trace_data_stream.str() << endl;
}

/* Don't send trace data if the number of Simulation runs has exceeded the intended number */
if((!(GV_Experiment_Runs < Experiment_Runs_Count))&&(GV_Enable_Client_View_Trace==1))
{
   /* Record the number of times this activity has fired (as a "sanity" check for Trace logger) */
   ActionFiringCounts[0] = ActionFiringCounts[0] + 1;
   Trace_data_Client->send_data(trace_data_stream.str()); 
}


/****************************/
  return this;
}

/*======================TI_Next_OperationActivity========================*/

ClientSANSAN::TI_Next_OperationActivity::TI_Next_OperationActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("TI_Next_Operation",0,Deterministic, RaceEnabled, 5,3, true);
}

ClientSANSAN::TI_Next_OperationActivity::~TI_Next_OperationActivity(){
  delete[] TheDistributionParameters;
}

void ClientSANSAN::TI_Next_OperationActivity::LinkVariables(){
  Next_Operation->Register(&Next_Operation_Mobius_Mark);
  Start_Clients->Register(&Start_Clients_Mobius_Mark);
  Request_Operation_Client_1->Register(&Request_Operation_Client_1_Mobius_Mark);
  Client_ID->Register(&Client_ID_Mobius_Mark);
  Execute_Transaction->Register(&Execute_Transaction_Mobius_Mark);
  Next_Operation_Details_1->Register(&Next_Operation_Details_1_Mobius_Mark);
}

bool ClientSANSAN::TI_Next_OperationActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Next_Operation->Mark()==1)&&(Start_Clients->Mark()==1)&&(Request_Operation_Client_1->Mark()==0)));
  return NewEnabled;
}

double ClientSANSAN::TI_Next_OperationActivity::DeterministicParamValue(){
  return //400
//0.00125
//-5.4
//0.008
0.00002;
  return 1.0;  // default rate if none is specified
}

double ClientSANSAN::TI_Next_OperationActivity::Weight(){ 
  return 1;
}

bool ClientSANSAN::TI_Next_OperationActivity::ReactivationPredicate(){ 
  return 0;
}

bool ClientSANSAN::TI_Next_OperationActivity::ReactivationFunction(){ 
  return 0;
}

double ClientSANSAN::TI_Next_OperationActivity::SampleDistribution(){
  return //400
//0.00125
//-5.4
//0.008
0.00002;
}

double* ClientSANSAN::TI_Next_OperationActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int ClientSANSAN::TI_Next_OperationActivity::Rank(){
  return 1;
}

BaseActionClass* ClientSANSAN::TI_Next_OperationActivity::Fire(){
  Next_Operation->Mark()=0;

Request_Operation_Client_1->Mark()=1;


    if((GV_debug_flag==26)&&((ClientObjects[Client_ID->Mark()-1]->get_Shared_Data_Operation()).compare(std::string("Abort"))==0))
    {
       cerr << "IG_Next_Operation: Client " << Client_ID->Mark() << " has requested a transaction operation be performed at time " << BaseModelClass::LastActionTime << endl;
       cerr << "IG_Next_Operation: The value of Execute_Transaction->Mark() is " << Execute_Transaction->Mark() << endl;
       cerr << "IG_Next_Operation: The value of Request_Operation_Client_1->Mark() is " << Request_Operation_Client_1->Mark() << endl;
       cerr << "Next_Operation_Method.cpp: The value of Request_Operation_Client_1->Mark() is " << Request_Operation_Client_1->Mark() << endl;
       cerr << "Next_Operation_Method.cpp: The value of Execute_Transaction->Mark() is " << Execute_Transaction->Mark() << endl;
       cerr << "Next_Operation_Method.cpp: The value of Next_Operation_Details_1->Mark() is " << Next_Operation_Details_1->Mark() << endl;
    }

/***** Send Trace data ******/
/* Format:: Location : Origin : Destination : Trans_ID : Trans_Type : Operation_ID : Operation-type : Time-stamp */

std::stringstream trace_data_stream;

trace_data_stream << std::string(" IG_Next_Operation ") << std::string("Client ") << Client_ID->Mark() << std::string(" Client Server ") << Unbounded_Trans_ID[Client_ID->Mark()] << std::string(" ")  << (ClientObjects[Client_ID->Mark() - 1])->get_Trans_type_names((ClientObjects[Client_ID->Mark() - 1])->get_Trans_Profile_ID()) << std::string(" ") << (ClientObjects[Client_ID->Mark() - 1])->get_Trans_Profile_oper_ID() << std::string(" ") << ClientObjects[Client_ID->Mark()-1]->get_Shared_Data_Operation() << std::string(" ") << BaseModelClass::LastActionTime << std::string("\n");

if(GV_debug_flag==26)
{
    if((trace_data_stream.str()).find("Abort")!=(trace_data_stream.str()).npos)
    {
       cerr << trace_data_stream.str() << endl;
    }
}

/* Don't send trace data if the number of Simulation runs has exceeded the intended number */
if((!(GV_Experiment_Runs < Experiment_Runs_Count))&&(GV_Enable_Client_View_Trace==1))
{
   /* Record the number of times this activity fires (as a "sanity" check for the trace logger) */
   ActionFiringCounts[1] = ActionFiringCounts[1] + 1;
   Trace_data_Client->send_data(trace_data_stream.str()); 
}


/****************************/
  return this;
}

/*======================IA_End_TransActivity========================*/

ClientSANSAN::IA_End_TransActivity::IA_End_TransActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("IA_End_Trans",1,Deterministic, RaceEnabled, 3,1, false);
}

ClientSANSAN::IA_End_TransActivity::~IA_End_TransActivity(){
  delete[] TheDistributionParameters;
}

void ClientSANSAN::IA_End_TransActivity::LinkVariables(){
  End_Trans->Register(&End_Trans_Mobius_Mark);
  Client_ID->Register(&Client_ID_Mobius_Mark);
  Begin_Trans->Register(&Begin_Trans_Mobius_Mark);
}

bool ClientSANSAN::IA_End_TransActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((End_Trans->Mark()==1));
  return NewEnabled;
}

double ClientSANSAN::IA_End_TransActivity::DeterministicParamValue(){
  return 1e-23;
  return 1.0;  // default rate if none is specified
}

double ClientSANSAN::IA_End_TransActivity::Weight(){ 
  return 1;
}

bool ClientSANSAN::IA_End_TransActivity::ReactivationPredicate(){ 
  return false;
}

bool ClientSANSAN::IA_End_TransActivity::ReactivationFunction(){ 
  return false;
}

double ClientSANSAN::IA_End_TransActivity::SampleDistribution(){
  return 1e-23;
}

double* ClientSANSAN::IA_End_TransActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int ClientSANSAN::IA_End_TransActivity::Rank(){
  return 1;
}

BaseActionClass* ClientSANSAN::IA_End_TransActivity::Fire(){
  if(GV_debug_flag==26)
{
    std::cerr << "DIDERO_PC::ClientSAN: End Trans IG is being executed for Client " << Client_ID->Mark() << std::endl;
}

End_Trans->Mark()=0;
Begin_Trans->Mark()=1;
  return this;
}

/*======================IA_Begin_TransActivity========================*/

ClientSANSAN::IA_Begin_TransActivity::IA_Begin_TransActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("IA_Begin_Trans",2,Deterministic, RaceEnabled, 3,2, false);
}

ClientSANSAN::IA_Begin_TransActivity::~IA_Begin_TransActivity(){
  delete[] TheDistributionParameters;
}

void ClientSANSAN::IA_Begin_TransActivity::LinkVariables(){
  Begin_Trans->Register(&Begin_Trans_Mobius_Mark);
  Start_Clients->Register(&Start_Clients_Mobius_Mark);
  Client_ID->Register(&Client_ID_Mobius_Mark);
  Execute_Transaction->Register(&Execute_Transaction_Mobius_Mark);
}

bool ClientSANSAN::IA_Begin_TransActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Begin_Trans->Mark()==1)&&(Start_Clients->Mark()==1)));
  return NewEnabled;
}

double ClientSANSAN::IA_Begin_TransActivity::DeterministicParamValue(){
  return 1e-23
;
  return 1.0;  // default rate if none is specified
}

double ClientSANSAN::IA_Begin_TransActivity::Weight(){ 
  return 1;
}

bool ClientSANSAN::IA_Begin_TransActivity::ReactivationPredicate(){ 
  return false;
}

bool ClientSANSAN::IA_Begin_TransActivity::ReactivationFunction(){ 
  return false;
}

double ClientSANSAN::IA_Begin_TransActivity::SampleDistribution(){
  return 1e-23
;
}

double* ClientSANSAN::IA_Begin_TransActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int ClientSANSAN::IA_Begin_TransActivity::Rank(){
  return 1;
}

BaseActionClass* ClientSANSAN::IA_Begin_TransActivity::Fire(){
  /*Call method to either create a new transaction object or reset a preexisting transaction object */

if(GV_debug_flag==26)
{
    cerr << "Client " << Client_ID->Mark() << " is about to start a new transaction" << endl;
    cerr << "IG_Begin_Trans:: The value of the predicate Begin_Trans is " << Begin_Trans->Mark() << endl;
}

/* How many transactions have been instantiated for this Client so far */
Unbounded_Trans_ID[Client_ID->Mark()] = Unbounded_Trans_ID[Client_ID->Mark()] + 1;

Begin_Transaction(Client_ID->Mark());

/* Indicate that a new transaction has begun and notify the corresponding Transaction thread
   on the Server that a Transaction should be enabled. "Execute_Transaction" place will be 
   disabled by the respective transaction thread when a transaction is completed, Server-side. 
*/
Execute_Transaction->Mark()=1;


/* Disable the IA_Begin_Trans Instantaneous activity */
Begin_Trans->Mark()=0;

/* Record time-stamp in trace */
/***** Send Trace data ******/
/* Format:: Location 1: Location_ID : Origin : Destination : Trans_ID : Trans_Type : Operation_ID : Operation-type : Time-stamp */	

std::stringstream trace_data_stream;

//trace_data_stream << std::string("Client Client DivSQL ") << Unbounded_Trans_ID[Client_ID->Mark()] << std::string(" ")  << (ClientObjects[Client_ID->Mark() - 1])->get_Trans_type_names((ClientObjects[Client_ID->Mark() - 1])->get_Trans_Profile_ID()) << std::string(" ") << (ClientObjects[Client_ID->Mark() - 1])->get_Trans_Profile_oper_ID() << std::string(" ") << ((Oper_Data_for_Replicas[Client_ID->mark()])[(Oper_Data_for_Replicas[Client_ID->mark()]).size()])[0] << std::string(" ") << 

//trace_data_stream << std::string("Client ") << Client_ID->Mark() << std::string(" Client Server ") << Unbounded_Trans_ID[Client_ID->Mark()] << std::string(" ")  << (ClientObjects[Client_ID->Mark() - 1])->get_Trans_type_names((ClientObjects[Client_ID->Mark() - 1])->get_Trans_Profile_ID()) << std::string(" ") << ClientObjects[Client_ID->Mark() - 1]->get_Trans_Profile_oper_ID() << std::string(" ") << (ClientObjects[Client_ID->Mark()-1]->get_Oper_Exec_Status()) << std::string(" ") << BaseModelClass::LastActionTime << std::string("\n");
trace_data_stream << std::string(" IG_Begin_Trans ") << std::string("Client ") << Client_ID->Mark() << std::string(" Client Server ") << Unbounded_Trans_ID[Client_ID->Mark()] << std::string(" ")  << (ClientObjects[Client_ID->Mark() - 1])->get_Trans_type_names((ClientObjects[Client_ID->Mark() - 1])->get_Trans_Profile_ID()) << std::string(" ") << ClientObjects[Client_ID->Mark() - 1]->get_Trans_Profile_oper_ID() << std::string(" ") << std::string(" Begin ") << std::string(" ") << BaseModelClass::LastActionTime << std::string("\n");
/* NOTE on the above: the value of the Operation-type, returned by the method call "(ClientObjects[Client_ID->Mark()-1]->get_Oper_Exec_Status())", at this point in the simulation, is NULL */

if(GV_debug_flag==26)
{
   cerr << trace_data_stream.str() << endl;
}

/* Don't send trace data if the number of Simulation runs has exceeded the intended number */
if((!(GV_Experiment_Runs < Experiment_Runs_Count))&&(GV_Enable_Client_View_Trace==1))
{
   /* Record the number of times this activity has fired (as a "sanity" check for Trace logger) */
   ActionFiringCounts[0] = ActionFiringCounts[0] + 1;
   Trace_data_Client->send_data(trace_data_stream.str()); 
}


/****************************/
  return this;
}

