#ifndef ClientSANSAN_H_
#define ClientSANSAN_H_

#include "udf/DIDERO_PC.h"
#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern short GV_Number_of_Warehouses;
extern short GV_Num_Dist_per_Warehouses;
extern short GV_Number_of_Clients_and_Trans;
extern short GV_debug_flag;
extern double Prob_of_NewOrder;
extern double Prob_of_Payment;
extern double Prob_of_Orderstatus;
extern double Prob_of_Delivery;
extern double Prob_of_Stocklevel;
extern double Choose_Cust_using_ID;
extern double Prob_of_Local_Orderlines;
extern double Prob_of_Cust_ID;
extern double Prob_of_Bad_Cust;
extern int GV_Cust_per_District;
extern short GV_Enable_Client_View_Trace;
extern bool GV_Step_Inverse_Transform;
extern bool GV_TPCC;
extern bool GV_Couple_Server_Trans_Durations;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               ClientSANSAN Submodel Definition                   
*********************************************************************/

class ClientSANSAN:public SANModel{
public:

class IA_Assign_Client_IDActivity:public Activity {
public:

  Place* Client_ID;
  short* Client_ID_Mobius_Mark;
  Place* Number_of_Clients;
  short* Number_of_Clients_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Assign_Client_IDActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_Assign_Client_IDActivityActivity

class IA_Next_Operation_DetailsActivity:public Activity {
public:

  Place* Next_Operation_Details_1;
  short* Next_Operation_Details_1_Mobius_Mark;
  Place* Start_Clients;
  short* Start_Clients_Mobius_Mark;
  Place* Client_ID;
  short* Client_ID_Mobius_Mark;
  Place* Next_Operation;
  short* Next_Operation_Mobius_Mark;
  Place* Request_Operation_Client_1;
  short* Request_Operation_Client_1_Mobius_Mark;
  Place* Execute_Transaction;
  short* Execute_Transaction_Mobius_Mark;
  Place* End_Trans;
  short* End_Trans_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Next_Operation_DetailsActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_Next_Operation_DetailsActivityActivity

class TI_Next_OperationActivity:public Activity {
public:

  Place* Next_Operation;
  short* Next_Operation_Mobius_Mark;
  Place* Start_Clients;
  short* Start_Clients_Mobius_Mark;
  Place* Request_Operation_Client_1;
  short* Request_Operation_Client_1_Mobius_Mark;
  Place* Client_ID;
  short* Client_ID_Mobius_Mark;
  Place* Execute_Transaction;
  short* Execute_Transaction_Mobius_Mark;
  Place* Next_Operation_Details_1;
  short* Next_Operation_Details_1_Mobius_Mark;

  double* TheDistributionParameters;
  TI_Next_OperationActivity();
  ~TI_Next_OperationActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // TI_Next_OperationActivityActivity

class IA_End_TransActivity:public Activity {
public:

  Place* End_Trans;
  short* End_Trans_Mobius_Mark;
  Place* Client_ID;
  short* Client_ID_Mobius_Mark;
  Place* Begin_Trans;
  short* Begin_Trans_Mobius_Mark;

  double* TheDistributionParameters;
  IA_End_TransActivity();
  ~IA_End_TransActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // IA_End_TransActivityActivity

class IA_Begin_TransActivity:public Activity {
public:

  Place* Begin_Trans;
  short* Begin_Trans_Mobius_Mark;
  Place* Start_Clients;
  short* Start_Clients_Mobius_Mark;
  Place* Client_ID;
  short* Client_ID_Mobius_Mark;
  Place* Execute_Transaction;
  short* Execute_Transaction_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Begin_TransActivity();
  ~IA_Begin_TransActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // IA_Begin_TransActivityActivity

  //List of user-specified place names
  Place* Start_Clients;
  Place* Client_ID;
  Place* Number_of_Clients;
  Place* Begin_Trans;
  Place* Next_Operation;
  Place* Next_Operation_Details_1;
  Place* End_Trans;
  Place* Request_Operation_Client_1;
  Place* Execute_Transaction;

  // Create instances of all actvities
  IA_Assign_Client_IDActivity IA_Assign_Client_ID;
  IA_Next_Operation_DetailsActivity IA_Next_Operation_Details;
  TI_Next_OperationActivity TI_Next_Operation;
  IA_End_TransActivity IA_End_Trans;
  IA_Begin_TransActivity IA_Begin_Trans;
  //Create instances of all groups 
  PreselectGroup ImmediateGroup;
  PostselectGroup IA_Assign_Client_IDGroup;
  PostselectGroup IA_Next_Operation_DetailsGroup;

  ClientSANSAN();
  ~ClientSANSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end ClientSANSAN

#endif // ClientSANSAN_H_
