#ifndef InitializerSAN_H_
#define InitializerSAN_H_

#include "udf/DIDERO_PC.h"
#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern short GV_Number_of_Clients_and_Trans;
extern int GV_Experiment_Runs;
extern float GV_Oper_Dur_Raw_Data_Scaling;
extern short GV_Enable_Server_1_View_Trace;
extern double GV_ReacModel_ExpScaling;
extern double GV_ReacModel_PolyPower;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               InitializerSAN Submodel Definition                   
*********************************************************************/

class InitializerSAN:public SANModel{
public:

class IA_Create_Clients_MW_ServersActivity:public Activity {
public:

  Place* Start;
  short* Start_Mobius_Mark;
  Place* Client_Trans_IDs;
  short* Client_Trans_IDs_Mobius_Mark;
  Place* Start_Clients_and_Servers;
  short* Start_Clients_and_Servers_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Create_Clients_MW_ServersActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_Create_Clients_MW_ServersActivityActivity

  //List of user-specified place names
  Place* Start;
  Place* Start_Clients_and_Servers;
  Place* Client_Trans_IDs;
  Place* Init_Blocking_Pointers;

  // Create instances of all actvities
  IA_Create_Clients_MW_ServersActivity IA_Create_Clients_MW_Servers;
  //Create instances of all groups 
  PreselectGroup ImmediateGroup;
  PostselectGroup IA_Create_Clients_MW_ServersGroup;

  InitializerSAN();
  ~InitializerSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end InitializerSAN

#endif // InitializerSAN_H_
