#ifndef Middleware_SANSAN_H_
#define Middleware_SANSAN_H_

#include "udf/DIDERO_PC.h"
#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern bool GV_Server_1_enabled;
extern bool GV_Server_2_enabled;
extern bool GV_IntraTransaction_Dependence;
extern bool GV_IntraTransDepBurstiness;
extern bool GV_DefaultResidualTimes;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               Middleware_SANSAN Submodel Definition                   
*********************************************************************/

class Middleware_SANSAN:public SANModel{
public:

class IA_Buffer_1Activity:public Activity {
public:

  Place* Buffer_Operations;
  short* Buffer_Operations_Mobius_Mark;
  Place* Server_1_enabled;
  short* Server_1_enabled_Mobius_Mark;
  Place* Server_2_enabled;
  short* Server_2_enabled_Mobius_Mark;
  Place* Exception;
  short* Exception_Mobius_Mark;
  Place* Buffer_1_called;
  short* Buffer_1_called_Mobius_Mark;
  Place* Buffer_2_called;
  short* Buffer_2_called_Mobius_Mark;
  Place* Buffer_1_progress;
  short* Buffer_1_progress_Mobius_Mark;
  Place* Buffer_2_progress;
  short* Buffer_2_progress_Mobius_Mark;
  Place* Middleware_ID;
  short* Middleware_ID_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Buffer_1Activity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_Buffer_1ActivityActivity

class IA_Buffer_1_utilisationActivity:public Activity {
public:

  Place* Buffer_1_progress;
  short* Buffer_1_progress_Mobius_Mark;
  Place* Buffer_1_called;
  short* Buffer_1_called_Mobius_Mark;
  Place* Server_1_enabled;
  short* Server_1_enabled_Mobius_Mark;
  Place* Server_2_enabled;
  short* Server_2_enabled_Mobius_Mark;
  Place* Middleware_ID;
  short* Middleware_ID_Mobius_Mark;
  Place* Execute_Transaction_1;
  short* Execute_Transaction_1_Mobius_Mark;
  Place* Request_Operation_Server_1;
  short* Request_Operation_Server_1_Mobius_Mark;
  Place* Execute_Transaction_current;
  short* Execute_Transaction_current_Mobius_Mark;
  Place* Request_Operation_Server_current;
  short* Request_Operation_Server_current_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Buffer_1_utilisationActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_Buffer_1_utilisationActivityActivity

class IA_Buffer_2_utilisationActivity:public Activity {
public:

  Place* Buffer_2_progress;
  short* Buffer_2_progress_Mobius_Mark;
  Place* Buffer_2_called;
  short* Buffer_2_called_Mobius_Mark;
  Place* Server_1_enabled;
  short* Server_1_enabled_Mobius_Mark;
  Place* Server_2_enabled;
  short* Server_2_enabled_Mobius_Mark;
  Place* Middleware_ID;
  short* Middleware_ID_Mobius_Mark;
  Place* Execute_Transaction_2;
  short* Execute_Transaction_2_Mobius_Mark;
  Place* Request_Operation_Server_2;
  short* Request_Operation_Server_2_Mobius_Mark;
  Place* Execute_Transaction_current;
  short* Execute_Transaction_current_Mobius_Mark;
  Place* Request_Operation_Server_current;
  short* Request_Operation_Server_current_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Buffer_2_utilisationActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_Buffer_2_utilisationActivityActivity

class IA_Signal_ServerActivity:public Activity {
public:

  Place* Signal_Server;
  short* Signal_Server_Mobius_Mark;
  Place* Server_1_enabled;
  short* Server_1_enabled_Mobius_Mark;
  Place* Request_Operation_Server_1;
  short* Request_Operation_Server_1_Mobius_Mark;
  Place* Request_Operation_Server_current;
  short* Request_Operation_Server_current_Mobius_Mark;
  Place* Execute_Transaction_1;
  short* Execute_Transaction_1_Mobius_Mark;
  Place* Execute_Transaction_current;
  short* Execute_Transaction_current_Mobius_Mark;
  Place* Server_2_enabled;
  short* Server_2_enabled_Mobius_Mark;
  Place* Request_Operation_Server_2;
  short* Request_Operation_Server_2_Mobius_Mark;
  Place* Execute_Transaction_2;
  short* Execute_Transaction_2_Mobius_Mark;
  Place* Middleware_ID;
  short* Middleware_ID_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Signal_ServerActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_Signal_ServerActivityActivity

class IA_Results_SingleServerActivity:public Activity {
public:

  Place* Server_1_enabled;
  short* Server_1_enabled_Mobius_Mark;
  Place* Server_2_enabled;
  short* Server_2_enabled_Mobius_Mark;
  Place* Operation_Executed_Server_1;
  short* Operation_Executed_Server_1_Mobius_Mark;
  Place* Operation_Executed_Server_2;
  short* Operation_Executed_Server_2_Mobius_Mark;
  Place* Middleware_ID;
  short* Middleware_ID_Mobius_Mark;
  Place* Operation_Executed_current;
  short* Operation_Executed_current_Mobius_Mark;
  Place* Execute_Transaction_current;
  short* Execute_Transaction_current_Mobius_Mark;
  Place* Execute_Transaction_1;
  short* Execute_Transaction_1_Mobius_Mark;
  Place* Request_Operation_Server_current;
  short* Request_Operation_Server_current_Mobius_Mark;
  Place* Request_Operation_Server_1;
  short* Request_Operation_Server_1_Mobius_Mark;
  Place* Oper_Edge_detection_called;
  short* Oper_Edge_detection_called_Mobius_Mark;
  Place* Execute_Transaction_2;
  short* Execute_Transaction_2_Mobius_Mark;
  Place* Request_Operation_Server_2;
  short* Request_Operation_Server_2_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Results_SingleServerActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_Results_SingleServerActivityActivity

class IA_ExceptionActivity:public Activity {
public:

  Place* Exception;
  short* Exception_Mobius_Mark;
  Place* Operation_Executed_Server_1;
  short* Operation_Executed_Server_1_Mobius_Mark;
  Place* Operation_Executed_Server_2;
  short* Operation_Executed_Server_2_Mobius_Mark;
  Place* Request_Operation_Server_current;
  short* Request_Operation_Server_current_Mobius_Mark;
  Place* Execute_Transaction_current;
  short* Execute_Transaction_current_Mobius_Mark;
  Place* Oper_Edge_detection_called;
  short* Oper_Edge_detection_called_Mobius_Mark;
  Place* Middleware_ID;
  short* Middleware_ID_Mobius_Mark;
  Place* Buffer_1_progress;
  short* Buffer_1_progress_Mobius_Mark;
  Place* Buffer_2_progress;
  short* Buffer_2_progress_Mobius_Mark;
  Place* Operation_Executed_current;
  short* Operation_Executed_current_Mobius_Mark;
  Place* Execute_Transaction_1;
  short* Execute_Transaction_1_Mobius_Mark;
  Place* Request_Operation_Server_1;
  short* Request_Operation_Server_1_Mobius_Mark;

  double* TheDistributionParameters;
  IA_ExceptionActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_ExceptionActivityActivity

class TA_Mutex_poolActivity:public Activity {
public:

  Place* Mutex_pool;
  short* Mutex_pool_Mobius_Mark;
  Place* Mutex_requested;
  short* Mutex_requested_Mobius_Mark;
  Place* Mutex_granted;
  short* Mutex_granted_Mobius_Mark;
  Place* Server_1_enabled;
  short* Server_1_enabled_Mobius_Mark;
  Place* Server_2_enabled;
  short* Server_2_enabled_Mobius_Mark;
  Place* Exception;
  short* Exception_Mobius_Mark;
  Place* Middleware_ID;
  short* Middleware_ID_Mobius_Mark;
  Place* Request_Operation_Server_1;
  short* Request_Operation_Server_1_Mobius_Mark;
  Place* Request_Operation_Server_current;
  short* Request_Operation_Server_current_Mobius_Mark;
  Place* Execute_Transaction_1;
  short* Execute_Transaction_1_Mobius_Mark;
  Place* Execute_Transaction_current;
  short* Execute_Transaction_current_Mobius_Mark;
  Place* Request_Operation_Server_2;
  short* Request_Operation_Server_2_Mobius_Mark;
  Place* Execute_Transaction_2;
  short* Execute_Transaction_2_Mobius_Mark;

  double* TheDistributionParameters;
  TA_Mutex_poolActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // TA_Mutex_poolActivityActivity

class TA_ResultsActivity:public Activity {
public:

  Place* Mutex_granted;
  short* Mutex_granted_Mobius_Mark;
  Place* Middleware_ID;
  short* Middleware_ID_Mobius_Mark;
  Place* Operation_Executed_Server_1;
  short* Operation_Executed_Server_1_Mobius_Mark;
  Place* Operation_Executed_Server_2;
  short* Operation_Executed_Server_2_Mobius_Mark;
  Place* Server_1_enabled;
  short* Server_1_enabled_Mobius_Mark;
  Place* Server_2_enabled;
  short* Server_2_enabled_Mobius_Mark;
  Place* Exception;
  short* Exception_Mobius_Mark;
  Place* Execute_Transaction_current;
  short* Execute_Transaction_current_Mobius_Mark;
  Place* Operation_Executed_current;
  short* Operation_Executed_current_Mobius_Mark;
  Place* Request_Operation_Server_current;
  short* Request_Operation_Server_current_Mobius_Mark;
  Place* Request_Operation_Server_1;
  short* Request_Operation_Server_1_Mobius_Mark;
  Place* Execute_Transaction_1;
  short* Execute_Transaction_1_Mobius_Mark;
  Place* Oper_Edge_detection_called;
  short* Oper_Edge_detection_called_Mobius_Mark;
  Place* Request_Operation_Server_2;
  short* Request_Operation_Server_2_Mobius_Mark;
  Place* Execute_Transaction_2;
  short* Execute_Transaction_2_Mobius_Mark;
  Place* Buffer_Operations;
  short* Buffer_Operations_Mobius_Mark;
  Place* Buffer_1_called;
  short* Buffer_1_called_Mobius_Mark;
  Place* Buffer_1_progress;
  short* Buffer_1_progress_Mobius_Mark;
  Place* Buffer_2_called;
  short* Buffer_2_called_Mobius_Mark;
  Place* Buffer_2_progress;
  short* Buffer_2_progress_Mobius_Mark;
  Place* Wait_for_slower_server;
  short* Wait_for_slower_server_Mobius_Mark;

  double* TheDistributionParameters;
  TA_ResultsActivity();
  ~TA_ResultsActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // TA_ResultsActivityActivity

class TA_Oper_Edge_detectionActivity:public Activity {
public:

  Place* Server_1_enabled;
  short* Server_1_enabled_Mobius_Mark;
  Place* Begin_called_1;
  short* Begin_called_1_Mobius_Mark;
  Place* Request_Operation_Server_current;
  short* Request_Operation_Server_current_Mobius_Mark;
  Place* Execute_Transaction_current;
  short* Execute_Transaction_current_Mobius_Mark;
  Place* Server_2_enabled;
  short* Server_2_enabled_Mobius_Mark;
  Place* Begin_called_2;
  short* Begin_called_2_Mobius_Mark;
  Place* Oper_Edge_detection_called;
  short* Oper_Edge_detection_called_Mobius_Mark;
  Place* Exception;
  short* Exception_Mobius_Mark;
  Place* Operation_Executed_current;
  short* Operation_Executed_current_Mobius_Mark;
  Place* Middleware_ID;
  short* Middleware_ID_Mobius_Mark;
  Place* Mutex_pool;
  short* Mutex_pool_Mobius_Mark;
  Place* Mutex_requested;
  short* Mutex_requested_Mobius_Mark;
  Place* Mutex_granted;
  short* Mutex_granted_Mobius_Mark;
  Place* Buffer_Operations;
  short* Buffer_Operations_Mobius_Mark;
  Place* Signal_Server;
  short* Signal_Server_Mobius_Mark;

  double* TheDistributionParameters;
  TA_Oper_Edge_detectionActivity();
  ~TA_Oper_Edge_detectionActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // TA_Oper_Edge_detectionActivityActivity

class TA_Mutex_releaseActivity:public Activity {
public:

  Place* Mutex_granted;
  short* Mutex_granted_Mobius_Mark;
  Place* Middleware_ID;
  short* Middleware_ID_Mobius_Mark;
  Place* Operation_Executed_Server_1;
  short* Operation_Executed_Server_1_Mobius_Mark;
  Place* Operation_Executed_Server_2;
  short* Operation_Executed_Server_2_Mobius_Mark;
  Place* Server_1_enabled;
  short* Server_1_enabled_Mobius_Mark;
  Place* Server_2_enabled;
  short* Server_2_enabled_Mobius_Mark;
  Place* Mutex_pool;
  short* Mutex_pool_Mobius_Mark;
  Place* Mutex_requested;
  short* Mutex_requested_Mobius_Mark;
  Place* Exception;
  short* Exception_Mobius_Mark;

  double* TheDistributionParameters;
  TA_Mutex_releaseActivity();
  ~TA_Mutex_releaseActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // TA_Mutex_releaseActivityActivity

  //List of user-specified place names
  Place* Execute_Transaction_current;
  Place* Request_Operation_Server_current;
  Place* Request_Operation_Server_1;
  Place* Execute_Transaction_1;
  Place* Request_Operation_Server_2;
  Place* Execute_Transaction_2;
  Place* Mutex_pool;
  Place* Server_1_enabled;
  Place* Server_2_enabled;
  Place* Mutex_granted;
  Place* Mutex_requested;
  Place* Middleware_ID;
  Place* Operation_Executed_Server_1;
  Place* Operation_Executed_Server_2;
  Place* Buffer_Operations;
  Place* Signal_Server;
  Place* Oper_Edge_detection_called;
  Place* Buffer_1_progress;
  Place* Buffer_2_progress;
  Place* Buffer_1_called;
  Place* Buffer_2_called;
  Place* Operation_Executed_current;
  Place* Exception;
  Place* Begin_called_1;
  Place* Begin_called_2;
  Place* Wait_for_slower_server;

  // Create instances of all actvities
  IA_Buffer_1Activity IA_Buffer_1;
  IA_Buffer_1_utilisationActivity IA_Buffer_1_utilisation;
  IA_Buffer_2_utilisationActivity IA_Buffer_2_utilisation;
  IA_Signal_ServerActivity IA_Signal_Server;
  IA_Results_SingleServerActivity IA_Results_SingleServer;
  IA_ExceptionActivity IA_Exception;
  TA_Mutex_poolActivity TA_Mutex_pool;
  TA_ResultsActivity TA_Results;
  TA_Oper_Edge_detectionActivity TA_Oper_Edge_detection;
  TA_Mutex_releaseActivity TA_Mutex_release;
  //Create instances of all groups 
  PreselectGroup ImmediateGroup;
  PostselectGroup IA_Buffer_1Group;
  PostselectGroup IA_Buffer_1_utilisationGroup;
  PostselectGroup IA_Buffer_2_utilisationGroup;
  PostselectGroup IA_Signal_ServerGroup;
  PostselectGroup IA_Results_SingleServerGroup;
  PostselectGroup IA_ExceptionGroup;
  PostselectGroup TA_Mutex_poolGroup;

  Middleware_SANSAN();
  ~Middleware_SANSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end Middleware_SANSAN

#endif // Middleware_SANSAN_H_
