#ifndef TransactionSAN_1SAN_H_
#define TransactionSAN_1SAN_H_

#include "udf/DIDERO_PC.h"
#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern double GV_Server_1_Prob_of_IntraTransDependence;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               TransactionSAN_1SAN Submodel Definition                   
*********************************************************************/

class TransactionSAN_1SAN:public SANModel{
public:

class IA_ReacPulse_Begin_EdgeActivity:public Activity {
public:

  Place* Execute_Transaction;
  short* Execute_Transaction_Mobius_Mark;
  Place* Request_Operation_Server;
  short* Request_Operation_Server_Mobius_Mark;
  Place* ReacPulse_Once;
  short* ReacPulse_Once_Mobius_Mark;
  Place* Begin_Success;
  short* Begin_Success_Mobius_Mark;
  Place* Begin_Edge_Called;
  short* Begin_Edge_Called_Mobius_Mark;
  Place* Begin_Server_1;
  short* Begin_Server_1_Mobius_Mark;
  Place* ReacPulse_local;
  short* ReacPulse_local_Mobius_Mark;
  Place* Begin_Edge;
  short* Begin_Edge_Mobius_Mark;

  double* TheDistributionParameters;
  IA_ReacPulse_Begin_EdgeActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_ReacPulse_Begin_EdgeActivityActivity

class IA_ReacPulse_OperActivity:public Activity {
public:

  Place* ReacPulse_Once;
  short* ReacPulse_Once_Mobius_Mark;
  Place* Execute_Transaction;
  short* Execute_Transaction_Mobius_Mark;
  Place* Request_Operation_Server;
  short* Request_Operation_Server_Mobius_Mark;
  Place* Oper;
  short* Oper_Mobius_Mark;
  Place* Start_Servers;
  short* Start_Servers_Mobius_Mark;
  Place* Oper_Called;
  short* Oper_Called_Mobius_Mark;
  Place* ReacPulse_local;
  short* ReacPulse_local_Mobius_Mark;

  double* TheDistributionParameters;
  IA_ReacPulse_OperActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_ReacPulse_OperActivityActivity

class IA_Init_Blocking_PtrsActivity:public Activity {
public:

  Place* Init_Success;
  short* Init_Success_Mobius_Mark;
  Place* Trans_ID;
  short* Trans_ID_Mobius_Mark;
  Place* Init_Blocking_Ptrs;
  short* Init_Blocking_Ptrs_Mobius_Mark;
  Place* Blocked;
  short* Blocked_Mobius_Mark;
  Place* Place_Unblocking;
  short* Place_Unblocking_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Init_Blocking_PtrsActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_Init_Blocking_PtrsActivityActivity

class IA_UnblockingActivity:public Activity {
public:

  Place* Start_Servers;
  short* Start_Servers_Mobius_Mark;
  Place* Place_Unblocking;
  short* Place_Unblocking_Mobius_Mark;
  Place* Trans_ID;
  short* Trans_ID_Mobius_Mark;
  Place* Blocked;
  short* Blocked_Mobius_Mark;
  Place* Server_ID;
  short* Server_ID_Mobius_Mark;
  Place* ReacPulse_local;
  short* ReacPulse_local_Mobius_Mark;
  Place* ReacPulse_2;
  short* ReacPulse_2_Mobius_Mark;
  Place* Oper;
  short* Oper_Mobius_Mark;
  Place* Oper_Called;
  short* Oper_Called_Mobius_Mark;

  double* TheDistributionParameters;
  IA_UnblockingActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // IA_UnblockingActivityActivity

class TA_Execute_OperationActivity:public Activity {
public:

  Place* Execute_Transaction;
  short* Execute_Transaction_Mobius_Mark;
  Place* Request_Operation_Server;
  short* Request_Operation_Server_Mobius_Mark;
  Place* Start_Servers;
  short* Start_Servers_Mobius_Mark;
  Place* ReacPulse_local;
  short* ReacPulse_local_Mobius_Mark;
  Place* Oper_Server_1;
  short* Oper_Server_1_Mobius_Mark;
  Place* Begin_Edge;
  short* Begin_Edge_Mobius_Mark;
  Place* ReacPulse_2;
  short* ReacPulse_2_Mobius_Mark;
  Place* Oper;
  short* Oper_Mobius_Mark;
  Place* Trans_ID;
  short* Trans_ID_Mobius_Mark;
  Place* Server_ID;
  short* Server_ID_Mobius_Mark;
  Place* Oper_Called;
  short* Oper_Called_Mobius_Mark;
  Place* Begin_Success;
  short* Begin_Success_Mobius_Mark;
  Place* Blocked;
  short* Blocked_Mobius_Mark;

  double* TheDistributionParameters;
  TA_Execute_OperationActivity();
  ~TA_Execute_OperationActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // TA_Execute_OperationActivityActivity

class TA_Begin_Server_2Activity:public Activity {
public:

  Place* Begin_Server_1;
  short* Begin_Server_1_Mobius_Mark;
  Place* Request_Operation_Server;
  short* Request_Operation_Server_Mobius_Mark;
  Place* Start_Servers;
  short* Start_Servers_Mobius_Mark;
  Place* ReacPulse_local;
  short* ReacPulse_local_Mobius_Mark;
  Place* Begin_Success;
  short* Begin_Success_Mobius_Mark;
  Place* Begin_Edge;
  short* Begin_Edge_Mobius_Mark;
  Place* ReacPulse_2;
  short* ReacPulse_2_Mobius_Mark;
  Place* Oper;
  short* Oper_Mobius_Mark;
  Place* Begin_Edge_Called;
  short* Begin_Edge_Called_Mobius_Mark;
  Place* Server_ID;
  short* Server_ID_Mobius_Mark;
  Place* Trans_ID;
  short* Trans_ID_Mobius_Mark;

  double* TheDistributionParameters;
  TA_Begin_Server_2Activity();
  ~TA_Begin_Server_2Activity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // TA_Begin_Server_2ActivityActivity

class IA_ReacPulse_2Activity:public Activity {
public:

  Place* ReacPulse_2;
  short* ReacPulse_2_Mobius_Mark;
  Place* ReacPulse_local;
  short* ReacPulse_local_Mobius_Mark;
  Place* Start_Servers;
  short* Start_Servers_Mobius_Mark;
  Place* Begin_Server_1;
  short* Begin_Server_1_Mobius_Mark;
  Place* Request_Operation_Server;
  short* Request_Operation_Server_Mobius_Mark;
  Place* Begin_Success;
  short* Begin_Success_Mobius_Mark;
  Place* Begin_Edge;
  short* Begin_Edge_Mobius_Mark;
  Place* Begin_Edge_Called;
  short* Begin_Edge_Called_Mobius_Mark;
  Place* Execute_Transaction;
  short* Execute_Transaction_Mobius_Mark;
  Place* Oper;
  short* Oper_Mobius_Mark;
  Place* Oper_Called;
  short* Oper_Called_Mobius_Mark;
  Place* Oper_Server_1;
  short* Oper_Server_1_Mobius_Mark;
  Place* Blocked;
  short* Blocked_Mobius_Mark;
  Place* ReacPulse_Once;
  short* ReacPulse_Once_Mobius_Mark;
  Place* Operation_Executed_Server_1;
  short* Operation_Executed_Server_1_Mobius_Mark;

  double* TheDistributionParameters;
  IA_ReacPulse_2Activity();
  ~IA_ReacPulse_2Activity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // IA_ReacPulse_2ActivityActivity

class IA_Begin_EdgeActivity:public Activity {
public:

  Place* Begin_Edge;
  short* Begin_Edge_Mobius_Mark;
  Place* Begin_Edge_Called;
  short* Begin_Edge_Called_Mobius_Mark;
  Place* Begin_Server_1;
  short* Begin_Server_1_Mobius_Mark;
  Place* Request_Operation_Server;
  short* Request_Operation_Server_Mobius_Mark;
  Place* Begin_Success;
  short* Begin_Success_Mobius_Mark;
  Place* ReacPulse_local;
  short* ReacPulse_local_Mobius_Mark;
  Place* Server_ID;
  short* Server_ID_Mobius_Mark;
  Place* Trans_ID;
  short* Trans_ID_Mobius_Mark;

  double* TheDistributionParameters;
  IA_Begin_EdgeActivity();
  ~IA_Begin_EdgeActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // IA_Begin_EdgeActivityActivity

class IA_OperActivity:public Activity {
public:

  Place* Blocked;
  short* Blocked_Mobius_Mark;
  Place* Place_Unblocking;
  short* Place_Unblocking_Mobius_Mark;
  Place* Oper_Server_1;
  short* Oper_Server_1_Mobius_Mark;
  Place* Oper;
  short* Oper_Mobius_Mark;
  Place* Start_Servers;
  short* Start_Servers_Mobius_Mark;
  Place* Oper_Called;
  short* Oper_Called_Mobius_Mark;
  Place* Request_Operation_Server;
  short* Request_Operation_Server_Mobius_Mark;
  Place* ReacPulse_local;
  short* ReacPulse_local_Mobius_Mark;
  Place* Server_ID;
  short* Server_ID_Mobius_Mark;
  Place* Trans_ID;
  short* Trans_ID_Mobius_Mark;

  double* TheDistributionParameters;
  IA_OperActivity();
  ~IA_OperActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // IA_OperActivityActivity

  //List of user-specified place names
  Place* Operation_Executed_Server_1;
  Place* Request_Operation_Server;
  Place* Start_Servers;
  Place* Trans_ID;
  Place* Server_ID;
  Place* Begin_Server_1;
  Place* Begin_Edge;
  Place* Execute_Transaction;
  Place* Begin_Edge_Called;
  Place* Oper;
  Place* Oper_Server_1;
  Place* ReacPulse_2;
  Place* ReacPulse_local;
  Place* Oper_Called;
  Place* Begin_Success;
  Place* ReacPulse_Once;
  Place* Blocked;
  Place* Init_Blocking_Ptrs;
  Place* Init_Success;
  Place* Place_Unblocking;

  // Create instances of all actvities
  IA_ReacPulse_Begin_EdgeActivity IA_ReacPulse_Begin_Edge;
  IA_ReacPulse_OperActivity IA_ReacPulse_Oper;
  IA_Init_Blocking_PtrsActivity IA_Init_Blocking_Ptrs;
  IA_UnblockingActivity IA_Unblocking;
  TA_Execute_OperationActivity TA_Execute_Operation;
  TA_Begin_Server_2Activity TA_Begin_Server_2;
  IA_ReacPulse_2Activity IA_ReacPulse_2;
  IA_Begin_EdgeActivity IA_Begin_Edge;
  IA_OperActivity IA_Oper;
  //Create instances of all groups 
  PreselectGroup ImmediateGroup;
  PostselectGroup IA_ReacPulse_Begin_EdgeGroup;
  PostselectGroup IA_ReacPulse_OperGroup;
  PostselectGroup IA_Init_Blocking_PtrsGroup;
  PostselectGroup IA_UnblockingGroup;

  TransactionSAN_1SAN();
  ~TransactionSAN_1SAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end TransactionSAN_1SAN

#endif // TransactionSAN_1SAN_H_
