

// This C++ file was created by SanEditor

#include "Atomic/TransactionSAN_2/TransactionSAN_2SAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         TransactionSAN_2SAN Constructor             
******************************************************************/


TransactionSAN_2SAN::TransactionSAN_2SAN(){


  Activity* InitialActionList[7]={
    &IA_ReacPulse_Begin_Edge, //0
    &IA_ReacPulse_Oper, //1
    &TA_Execute_Operation, //2
    &TA_Begin_Server_2, //3
    &IA_ReacPulse_2, //4
    &IA_Begin_Edge, //5
    &IA_Oper  // 6
  };

  BaseGroupClass* InitialGroupList[7]={
    (BaseGroupClass*) &(TA_Execute_Operation), 
    (BaseGroupClass*) &(TA_Begin_Server_2), 
    (BaseGroupClass*) &(IA_ReacPulse_2), 
    (BaseGroupClass*) &(IA_Begin_Edge), 
    (BaseGroupClass*) &(IA_Oper), 
    (BaseGroupClass*) &(IA_ReacPulse_Begin_Edge), 
    (BaseGroupClass*) &(IA_ReacPulse_Oper)
  };

  Operation_Executed_Server_2 = new Place("Operation_Executed_Server_2" ,0);
  Request_Operation_Server = new Place("Request_Operation_Server" ,0);
  Start_Servers = new Place("Start_Servers" ,0);
  Trans_ID = new Place("Trans_ID" ,0);
  Server_ID = new Place("Server_ID" ,2);
  Begin_Server_2 = new Place("Begin_Server_2" ,0);
  Begin_Edge = new Place("Begin_Edge" ,0);
  Execute_Transaction = new Place("Execute_Transaction" ,0);
  Begin_Edge_Called = new Place("Begin_Edge_Called" ,0);
  Oper = new Place("Oper" ,0);
  Oper_Server_2 = new Place("Oper_Server_2" ,0);
  ReacPulse_2 = new Place("ReacPulse_2" ,0);
  ReacPulse_local = new Place("ReacPulse_local" ,0);
  Oper_Called = new Place("Oper_Called" ,0);
  Begin_Success = new Place("Begin_Success" ,0);
  ReacPulse_Once = new Place("ReacPulse_Once" ,0);
  BaseStateVariableClass* InitialPlaces[16]={
    Operation_Executed_Server_2,  // 0
    Request_Operation_Server,  // 1
    Start_Servers,  // 2
    Trans_ID,  // 3
    Server_ID,  // 4
    Begin_Server_2,  // 5
    Begin_Edge,  // 6
    Execute_Transaction,  // 7
    Begin_Edge_Called,  // 8
    Oper,  // 9
    Oper_Server_2,  // 10
    ReacPulse_2,  // 11
    ReacPulse_local,  // 12
    Oper_Called,  // 13
    Begin_Success,  // 14
    ReacPulse_Once   // 15
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("TransactionSAN_2", 16, InitialPlaces, 
                        0, InitialROPlaces, 
                        7, InitialActionList, 7, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[64][2]={ 
    {7,0}, {8,0}, {1,0}, {5,0}, {12,0}, {14,0}, {6,0}, {15,0}, 
    {7,1}, {9,1}, {1,1}, {2,1}, {13,1}, {12,1}, {15,1}, {7,2}, 
    {1,2}, {2,2}, {12,2}, {10,2}, {13,2}, {11,2}, {4,2}, {3,2}, 
    {14,2}, {5,3}, {1,3}, {2,3}, {12,3}, {14,3}, {8,3}, {4,3}, 
    {3,3}, {11,3}, {11,4}, {12,4}, {2,4}, {5,4}, {1,4}, {14,4}, 
    {6,4}, {8,4}, {7,4}, {9,4}, {13,4}, {10,4}, {0,4}, {15,4}, 
    {6,5}, {8,5}, {5,5}, {1,5}, {14,5}, {12,5}, {4,5}, {3,5}, 
    {10,6}, {9,6}, {2,6}, {13,6}, {1,6}, {12,6}, {4,6}, {3,6}
  };
  for(int n=0;n<64;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[38][2]={ 
    {7,0}, {1,0}, {15,0}, {14,0}, {15,1}, {7,1}, {1,1}, {7,2}, 
    {1,2}, {2,2}, {12,2}, {10,2}, {6,2}, {11,2}, {9,2}, {5,3}, 
    {1,3}, {2,3}, {12,3}, {14,3}, {6,3}, {11,3}, {9,3}, {11,4}, 
    {12,4}, {2,4}, {6,5}, {8,5}, {5,5}, {1,5}, {14,5}, {12,5}, 
    {10,6}, {9,6}, {2,6}, {13,6}, {1,6}, {12,6}
  };
  for(int n=0;n<38;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<7;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void TransactionSAN_2SAN::CustomInitialization() {

}
TransactionSAN_2SAN::~TransactionSAN_2SAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void TransactionSAN_2SAN::assignPlacesToActivitiesInst(){
  IA_ReacPulse_Begin_Edge.Execute_Transaction = (Place*) LocalStateVariables[7];
  IA_ReacPulse_Begin_Edge.Request_Operation_Server = (Place*) LocalStateVariables[1];
  IA_ReacPulse_Begin_Edge.ReacPulse_Once = (Place*) LocalStateVariables[15];
  IA_ReacPulse_Begin_Edge.Begin_Success = (Place*) LocalStateVariables[14];
  IA_ReacPulse_Begin_Edge.Begin_Edge_Called = (Place*) LocalStateVariables[8];
  IA_ReacPulse_Begin_Edge.Begin_Server_2 = (Place*) LocalStateVariables[5];
  IA_ReacPulse_Begin_Edge.ReacPulse_local = (Place*) LocalStateVariables[12];
  IA_ReacPulse_Begin_Edge.Begin_Edge = (Place*) LocalStateVariables[6];
  IA_ReacPulse_Oper.ReacPulse_Once = (Place*) LocalStateVariables[15];
  IA_ReacPulse_Oper.Execute_Transaction = (Place*) LocalStateVariables[7];
  IA_ReacPulse_Oper.Request_Operation_Server = (Place*) LocalStateVariables[1];
  IA_ReacPulse_Oper.Oper = (Place*) LocalStateVariables[9];
  IA_ReacPulse_Oper.Start_Servers = (Place*) LocalStateVariables[2];
  IA_ReacPulse_Oper.Oper_Called = (Place*) LocalStateVariables[13];
  IA_ReacPulse_Oper.ReacPulse_local = (Place*) LocalStateVariables[12];
}
void TransactionSAN_2SAN::assignPlacesToActivitiesTimed(){
  TA_Execute_Operation.Execute_Transaction = (Place*) LocalStateVariables[7];
  TA_Execute_Operation.Request_Operation_Server = (Place*) LocalStateVariables[1];
  TA_Execute_Operation.Start_Servers = (Place*) LocalStateVariables[2];
  TA_Execute_Operation.ReacPulse_local = (Place*) LocalStateVariables[12];
  TA_Execute_Operation.Oper_Server_2 = (Place*) LocalStateVariables[10];
  TA_Execute_Operation.Begin_Edge = (Place*) LocalStateVariables[6];
  TA_Execute_Operation.ReacPulse_2 = (Place*) LocalStateVariables[11];
  TA_Execute_Operation.Oper = (Place*) LocalStateVariables[9];
  TA_Execute_Operation.Oper_Called = (Place*) LocalStateVariables[13];
  TA_Execute_Operation.Server_ID = (Place*) LocalStateVariables[4];
  TA_Execute_Operation.Trans_ID = (Place*) LocalStateVariables[3];
  TA_Execute_Operation.Begin_Success = (Place*) LocalStateVariables[14];
  TA_Begin_Server_2.Begin_Server_2 = (Place*) LocalStateVariables[5];
  TA_Begin_Server_2.Request_Operation_Server = (Place*) LocalStateVariables[1];
  TA_Begin_Server_2.Start_Servers = (Place*) LocalStateVariables[2];
  TA_Begin_Server_2.ReacPulse_local = (Place*) LocalStateVariables[12];
  TA_Begin_Server_2.Begin_Success = (Place*) LocalStateVariables[14];
  TA_Begin_Server_2.Begin_Edge = (Place*) LocalStateVariables[6];
  TA_Begin_Server_2.ReacPulse_2 = (Place*) LocalStateVariables[11];
  TA_Begin_Server_2.Oper = (Place*) LocalStateVariables[9];
  TA_Begin_Server_2.Begin_Edge_Called = (Place*) LocalStateVariables[8];
  TA_Begin_Server_2.Server_ID = (Place*) LocalStateVariables[4];
  TA_Begin_Server_2.Trans_ID = (Place*) LocalStateVariables[3];
  IA_ReacPulse_2.ReacPulse_2 = (Place*) LocalStateVariables[11];
  IA_ReacPulse_2.ReacPulse_local = (Place*) LocalStateVariables[12];
  IA_ReacPulse_2.Start_Servers = (Place*) LocalStateVariables[2];
  IA_ReacPulse_2.Begin_Server_2 = (Place*) LocalStateVariables[5];
  IA_ReacPulse_2.Request_Operation_Server = (Place*) LocalStateVariables[1];
  IA_ReacPulse_2.Begin_Success = (Place*) LocalStateVariables[14];
  IA_ReacPulse_2.Begin_Edge = (Place*) LocalStateVariables[6];
  IA_ReacPulse_2.Begin_Edge_Called = (Place*) LocalStateVariables[8];
  IA_ReacPulse_2.Execute_Transaction = (Place*) LocalStateVariables[7];
  IA_ReacPulse_2.Oper = (Place*) LocalStateVariables[9];
  IA_ReacPulse_2.Oper_Called = (Place*) LocalStateVariables[13];
  IA_ReacPulse_2.Oper_Server_2 = (Place*) LocalStateVariables[10];
  IA_ReacPulse_2.Operation_Executed_Server_2 = (Place*) LocalStateVariables[0];
  IA_ReacPulse_2.ReacPulse_Once = (Place*) LocalStateVariables[15];
  IA_Begin_Edge.Begin_Edge = (Place*) LocalStateVariables[6];
  IA_Begin_Edge.Begin_Edge_Called = (Place*) LocalStateVariables[8];
  IA_Begin_Edge.Begin_Server_2 = (Place*) LocalStateVariables[5];
  IA_Begin_Edge.Request_Operation_Server = (Place*) LocalStateVariables[1];
  IA_Begin_Edge.Begin_Success = (Place*) LocalStateVariables[14];
  IA_Begin_Edge.ReacPulse_local = (Place*) LocalStateVariables[12];
  IA_Begin_Edge.Server_ID = (Place*) LocalStateVariables[4];
  IA_Begin_Edge.Trans_ID = (Place*) LocalStateVariables[3];
  IA_Oper.Oper_Server_2 = (Place*) LocalStateVariables[10];
  IA_Oper.Oper = (Place*) LocalStateVariables[9];
  IA_Oper.Start_Servers = (Place*) LocalStateVariables[2];
  IA_Oper.Oper_Called = (Place*) LocalStateVariables[13];
  IA_Oper.Request_Operation_Server = (Place*) LocalStateVariables[1];
  IA_Oper.ReacPulse_local = (Place*) LocalStateVariables[12];
  IA_Oper.Server_ID = (Place*) LocalStateVariables[4];
  IA_Oper.Trans_ID = (Place*) LocalStateVariables[3];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================IA_ReacPulse_Begin_EdgeActivity========================*/


TransactionSAN_2SAN::IA_ReacPulse_Begin_EdgeActivity::IA_ReacPulse_Begin_EdgeActivity(){
  ActivityInitialize("IA_ReacPulse_Begin_Edge",5,Instantaneous , RaceEnabled, 8,4, false);
}

void TransactionSAN_2SAN::IA_ReacPulse_Begin_EdgeActivity::LinkVariables(){
  Execute_Transaction->Register(&Execute_Transaction_Mobius_Mark);
  Request_Operation_Server->Register(&Request_Operation_Server_Mobius_Mark);
  ReacPulse_Once->Register(&ReacPulse_Once_Mobius_Mark);
  Begin_Success->Register(&Begin_Success_Mobius_Mark);
  Begin_Edge_Called->Register(&Begin_Edge_Called_Mobius_Mark);
  Begin_Server_2->Register(&Begin_Server_2_Mobius_Mark);
  ReacPulse_local->Register(&ReacPulse_local_Mobius_Mark);
  Begin_Edge->Register(&Begin_Edge_Mobius_Mark);
}

bool TransactionSAN_2SAN::IA_ReacPulse_Begin_EdgeActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((//(Execute_Transaction->Mark()==1)&&(Begin_Edge_Called->Mark() == 0)&&(Request_Operation_Server->Mark()==0)&&(Begin_Server_2->Mark()==0)&&(ReacPulse_local->Mark()==0)&&(Begin_Success->Mark()==0)
(Execute_Transaction->Mark()==1)&&(Request_Operation_Server->Mark()==0)&&(ReacPulse_Once->Mark()==0)&&(Begin_Success->Mark()==0)
/* If the respective Client has sent a "begin transaction" signal to this server 
   "thread", but the signal has not been handled yet, then send a pulse to all 
   concurrent operations to reactiviate  
*/));
  return NewEnabled;
}

double TransactionSAN_2SAN::IA_ReacPulse_Begin_EdgeActivity::Weight(){ 
  return 1;
}

bool TransactionSAN_2SAN::IA_ReacPulse_Begin_EdgeActivity::ReactivationPredicate(){ 
  return false;
}

bool TransactionSAN_2SAN::IA_ReacPulse_Begin_EdgeActivity::ReactivationFunction(){ 
  return false;
}

double TransactionSAN_2SAN::IA_ReacPulse_Begin_EdgeActivity::SampleDistribution(){
  return 0;
}

double* TransactionSAN_2SAN::IA_ReacPulse_Begin_EdgeActivity::ReturnDistributionParameters(){
    return NULL;
}

int TransactionSAN_2SAN::IA_ReacPulse_Begin_EdgeActivity::Rank(){
  return 1;
}

BaseActionClass* TransactionSAN_2SAN::IA_ReacPulse_Begin_EdgeActivity::Fire(){
  if(GV_debug_flag==22)
{
   cerr << "TransactionSAN2::IG_ReacPulse_Begin_Edge : Predicate Check: The value of the predicate is " << ((Execute_Transaction->Mark()==1)&&(Begin_Edge_Called->Mark() == 0)&&(Request_Operation_Server->Mark()==0)&&(Begin_Server_2->Mark()==0)&&(ReacPulse_local->Mark()==0)&&(Begin_Success->Mark()==0)) << endl;
}

/* send a pulse to all concurrent operations to reactivate,
   but make sure this pulse is only sent once */
Begin_Edge->Mark() = Begin_Edge->Mark() + 1;
Begin_Edge_Called->Mark() = 1;
ReacPulse_Once->Mark()=1;
  return this;
}

/*======================IA_ReacPulse_OperActivity========================*/


TransactionSAN_2SAN::IA_ReacPulse_OperActivity::IA_ReacPulse_OperActivity(){
  ActivityInitialize("IA_ReacPulse_Oper",6,Instantaneous , RaceEnabled, 7,3, false);
}

void TransactionSAN_2SAN::IA_ReacPulse_OperActivity::LinkVariables(){
  ReacPulse_Once->Register(&ReacPulse_Once_Mobius_Mark);
  Execute_Transaction->Register(&Execute_Transaction_Mobius_Mark);
  Request_Operation_Server->Register(&Request_Operation_Server_Mobius_Mark);
  Oper->Register(&Oper_Mobius_Mark);
  Start_Servers->Register(&Start_Servers_Mobius_Mark);
  Oper_Called->Register(&Oper_Called_Mobius_Mark);
  ReacPulse_local->Register(&ReacPulse_local_Mobius_Mark);
}

bool TransactionSAN_2SAN::IA_ReacPulse_OperActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((//(Execute_Transaction->Mark()==1)&&(Request_Operation_Server->Mark()==1)&&(Start_Servers->Mark()==1)&&(Oper_Called->Mark()==0)&&(ReacPulse_local->Mark()==0)
(ReacPulse_Once->Mark()==0)&&(Execute_Transaction->Mark()==1)&&(Request_Operation_Server->Mark()==1)));
  return NewEnabled;
}

double TransactionSAN_2SAN::IA_ReacPulse_OperActivity::Weight(){ 
  return 1;
}

bool TransactionSAN_2SAN::IA_ReacPulse_OperActivity::ReactivationPredicate(){ 
  return false;
}

bool TransactionSAN_2SAN::IA_ReacPulse_OperActivity::ReactivationFunction(){ 
  return false;
}

double TransactionSAN_2SAN::IA_ReacPulse_OperActivity::SampleDistribution(){
  return 0;
}

double* TransactionSAN_2SAN::IA_ReacPulse_OperActivity::ReturnDistributionParameters(){
    return NULL;
}

int TransactionSAN_2SAN::IA_ReacPulse_OperActivity::Rank(){
  return 1;
}

BaseActionClass* TransactionSAN_2SAN::IA_ReacPulse_OperActivity::Fire(){
  if(GV_debug_flag==20)
{
   cerr << "IG_ReacPulse_Oper: Predicate Check: The value of the predicate is " << ((Execute_Transaction->Mark()==1)&&(Oper->Mark()==0)&&(Request_Operation_Server->Mark()==1)&&(Start_Servers->Mark()==1)&&(Oper_Called->Mark()==0)&&(ReacPulse_local->Mark()==0)) << endl;
}

Oper->Mark() = Oper->Mark() + 1;
Oper_Called->Mark() = 1;
ReacPulse_Once->Mark()=1;
  return this;
}

/*======================TA_Execute_OperationActivity========================*/

TransactionSAN_2SAN::TA_Execute_OperationActivity::TA_Execute_OperationActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("TA_Execute_Operation",0,Deterministic, RaceEnabled, 10,8, true);
}

TransactionSAN_2SAN::TA_Execute_OperationActivity::~TA_Execute_OperationActivity(){
  delete[] TheDistributionParameters;
}

void TransactionSAN_2SAN::TA_Execute_OperationActivity::LinkVariables(){
  Execute_Transaction->Register(&Execute_Transaction_Mobius_Mark);
  Request_Operation_Server->Register(&Request_Operation_Server_Mobius_Mark);
  Start_Servers->Register(&Start_Servers_Mobius_Mark);
  ReacPulse_local->Register(&ReacPulse_local_Mobius_Mark);
  Oper_Server_2->Register(&Oper_Server_2_Mobius_Mark);
  Begin_Edge->Register(&Begin_Edge_Mobius_Mark);
  ReacPulse_2->Register(&ReacPulse_2_Mobius_Mark);
  Oper->Register(&Oper_Mobius_Mark);
  Oper_Called->Register(&Oper_Called_Mobius_Mark);
  Server_ID->Register(&Server_ID_Mobius_Mark);
  Trans_ID->Register(&Trans_ID_Mobius_Mark);
  Begin_Success->Register(&Begin_Success_Mobius_Mark);
}

bool TransactionSAN_2SAN::TA_Execute_OperationActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Execute_Transaction->Mark()==1)&&(Request_Operation_Server->Mark()==1)&&(Start_Servers->Mark()==1)&&(ReacPulse_local->Mark() == 0)&&(Oper_Server_2->Mark() == 1)));
  return NewEnabled;
}

double TransactionSAN_2SAN::TA_Execute_OperationActivity::DeterministicParamValue(){
  //return Duration(All_Server_2_Transactions->Mark(), All_Server_2_Trans_CommitSuccess->Mark(), Commit_Trans_Server_2->Mark(), Trans_ID->Mark(), Server_ID->Mark());
return Duration(Trans_ID->Mark(), Server_ID->Mark(), BaseModelClass::LastActionTime);
  return 1.0;  // default rate if none is specified
}

double TransactionSAN_2SAN::TA_Execute_OperationActivity::Weight(){ 
  return 1;
}

bool TransactionSAN_2SAN::TA_Execute_OperationActivity::ReactivationPredicate(){ 
  return 1;
}

bool TransactionSAN_2SAN::TA_Execute_OperationActivity::ReactivationFunction(){ 
  return /* Is this true now, implying a reactivation should take place */
(Begin_Edge->Mark()>0)||(ReacPulse_2->Mark()>0)||(Oper->Mark()>0)
/* This activity should reactivate whenever an edge or operation 
   is being processed, or has been processed, on this server */;
}

double TransactionSAN_2SAN::TA_Execute_OperationActivity::SampleDistribution(){
  //return Duration(All_Server_2_Transactions->Mark(), All_Server_2_Trans_CommitSuccess->Mark(), Commit_Trans_Server_2->Mark(), Trans_ID->Mark(), Server_ID->Mark());
return Duration(Trans_ID->Mark(), Server_ID->Mark(), BaseModelClass::LastActionTime);
}

double* TransactionSAN_2SAN::TA_Execute_OperationActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int TransactionSAN_2SAN::TA_Execute_OperationActivity::Rank(){
  return 1;
}

BaseActionClass* TransactionSAN_2SAN::TA_Execute_OperationActivity::Fire(){
  if(GV_debug_flag==20)
{
   cerr << "IG_Execute_Operation : Predicate Check: The value of the predicate is " << ((Execute_Transaction->Mark()==1)&&(Request_Operation_Server->Mark()==1)&&(Start_Servers->Mark()==1)&&(ReacPulse_local->Mark() == 0)&&(Oper_Server_2->Mark() == 1)) << endl;
}

/* Reset trigger for the current operation to be executed*/
Oper_Server_2->Mark() = 0;
Oper_Called->Mark() = 0;

/* Set triggers to reactivate all other concurrent operations */
ReacPulse_local->Mark() = 1;
ReacPulse_2->Mark() = ReacPulse_2->Mark() + 1;

/* Reset the Sojourn-time value for this Activity */
(Sampled_SojournTimes[Server_ID->Mark()])[Trans_ID->Mark()] = 0;

/* Decrease the current operations count by 1 */
Current_Num_of_Oper[Server_ID->Mark()] = Current_Num_of_Oper[Server_ID->Mark()] - 1;

/* Indicate that the sojourn-time for this operation will be computed for the first time on the respective Server, next time around */
(PreviousEventTime[Server_ID->Mark()])[Trans_ID->Mark()] = 0.0;						

/* Call server method with ID, Key and operation type */
/* Check states of transactions to set those that need to be unblocked and aborted, if any */

std::string result = Exec_Trans_Method(Trans_ID->Mark(), Server_ID->Mark());

if((result.compare(std::string("Commit success"))==0)||(result.compare(std::string("Abort success"))==0))
{

if(GV_debug_flag==26)
{
   cerr << "DIDERO_PC_General::TransactionSAN_2.cpp::IG_Execute_Operation: Server " << Server_ID->Mark() << " has performed a request :" << result << ", by Client " << Trans_ID->Mark()<< endl;
}
   /* Indicate the end of a Transaction to the Client */
      Execute_Transaction->Mark()=0;
      Begin_Success->Mark()=0;	

     /* Reset the flag that indicates when at least one operation has been attempted
      * since the successful begin at the start of this transaction.
      * This flag is used by the "Durations.cpp"
      * file to generate the appropriate sojourn-times for the transaction's operations.
      */
      if((Begin_Status[Server_ID->Mark()])[Trans_ID->Mark()]==true)
      {
         (Begin_Status[Server_ID->Mark()])[Trans_ID->Mark()]=false;
      }
}

if(GV_debug_flag==20)
{
   cerr << "DIDERO_PC::TransactionSAN_2.cpp Server " << Server_ID->Mark() << " has performed a request :" << result << ", by Client " << Trans_ID->Mark()<< endl;
}

    if(GV_debug_flag==20)
    {
        if(result.compare(std::string("Read success"))==0)
        {
            std::cerr << "DIDERO_PC:TransactionSAN_2.cpp: The result of the operation just performed for Client " << Trans_ID->Mark() << " on Server " << Server_ID->Mark() << " is " << result << std::endl;  
        }
    }

/***** Send Trace data ******/
/* Format:: Location : Location_ID : Origin : Destination : Trans_ID : Trans_Type : Operation-type : Operation ID : Operation result : Time-stamp */

std::stringstream trace_data_stream;

trace_data_stream << std::string(" IG_Execute_Operation ") << std::string("Server ") << Trans_ID->Mark() << std::string(" Server_") << Server_ID->Mark() << std::string(" Client ") << Unbounded_Trans_ID[Trans_ID->Mark()] << std::string(" ")  << (ClientObjects[Trans_ID->Mark() - 1])->get_Trans_type_names((ClientObjects[Trans_ID->Mark() - 1])->get_Trans_Profile_ID()) << std::string(" ") << MW_ptr->Server_get_operation(Trans_ID->Mark(), Server_ID->Mark()) << std::string(" ") << MW_ptr->Server_get_Trans_oper_ID(Trans_ID->Mark(),Server_ID->Mark()) << std::string(" ") << result << std::string(" ") << BaseModelClass::LastActionTime << std::string("\n");

if(GV_debug_flag==20)
{
   cerr << trace_data_stream.str() << endl;
}

/* Don't send trace data if the number of Simulation runs has exceeded the intended number */
if((!(GV_Experiment_Runs < Experiment_Runs_Count))&&(GV_Enable_Server_2_View_Trace==1))
{
   /* Record the number of times this activity fires (as a "sanity" check for the trace logger) */
   ActionFiringCounts[5] = ActionFiringCounts[5] + 1; 
   Trace_data_Client->send_data(trace_data_stream.str()); 
}


/****************************/
  return this;
}

/*======================TA_Begin_Server_2Activity========================*/

TransactionSAN_2SAN::TA_Begin_Server_2Activity::TA_Begin_Server_2Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("TA_Begin_Server_2",1,Deterministic, RaceEnabled, 9,8, true);
}

TransactionSAN_2SAN::TA_Begin_Server_2Activity::~TA_Begin_Server_2Activity(){
  delete[] TheDistributionParameters;
}

void TransactionSAN_2SAN::TA_Begin_Server_2Activity::LinkVariables(){
  Begin_Server_2->Register(&Begin_Server_2_Mobius_Mark);
  Request_Operation_Server->Register(&Request_Operation_Server_Mobius_Mark);
  Start_Servers->Register(&Start_Servers_Mobius_Mark);
  ReacPulse_local->Register(&ReacPulse_local_Mobius_Mark);
  Begin_Success->Register(&Begin_Success_Mobius_Mark);
  Begin_Edge->Register(&Begin_Edge_Mobius_Mark);
  ReacPulse_2->Register(&ReacPulse_2_Mobius_Mark);
  Oper->Register(&Oper_Mobius_Mark);
  Begin_Edge_Called->Register(&Begin_Edge_Called_Mobius_Mark);
  Server_ID->Register(&Server_ID_Mobius_Mark);
  Trans_ID->Register(&Trans_ID_Mobius_Mark);
}

bool TransactionSAN_2SAN::TA_Begin_Server_2Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Begin_Server_2->Mark()==1)&&(Request_Operation_Server->Mark()==0)&&(Start_Servers->Mark()==1)&&(ReacPulse_local->Mark()==0)&&(Begin_Success->Mark()==0)));
  return NewEnabled;
}

double TransactionSAN_2SAN::TA_Begin_Server_2Activity::DeterministicParamValue(){
  //return Duration(All_Server_2_Transactions->Mark(), All_Server_2_Trans_CommitSuccess->Mark(), Commit_Trans_Server_2->Mark(), Trans_ID->Mark(), Server_ID->Mark());
return Duration(Trans_ID->Mark(), Server_ID->Mark(), BaseModelClass::LastActionTime);
  return 1.0;  // default rate if none is specified
}

double TransactionSAN_2SAN::TA_Begin_Server_2Activity::Weight(){ 
  return 1;
}

bool TransactionSAN_2SAN::TA_Begin_Server_2Activity::ReactivationPredicate(){ 
  return 1;
}

bool TransactionSAN_2SAN::TA_Begin_Server_2Activity::ReactivationFunction(){ 
  return (Begin_Edge->Mark()>0)||(ReacPulse_2->Mark()>0)||(Oper->Mark()>0)
/* This activity should reactivate whenever an edge or operation
   is being processed, or has just been processed, on this server*/;
}

double TransactionSAN_2SAN::TA_Begin_Server_2Activity::SampleDistribution(){
  //return Duration(All_Server_2_Transactions->Mark(), All_Server_2_Trans_CommitSuccess->Mark(), Commit_Trans_Server_2->Mark(), Trans_ID->Mark(), Server_ID->Mark());
return Duration(Trans_ID->Mark(), Server_ID->Mark(), BaseModelClass::LastActionTime);
}

double* TransactionSAN_2SAN::TA_Begin_Server_2Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int TransactionSAN_2SAN::TA_Begin_Server_2Activity::Rank(){
  return 1;
}

BaseActionClass* TransactionSAN_2SAN::TA_Begin_Server_2Activity::Fire(){
  if(GV_debug_flag==20)
{
   cerr << "IG_Begin_Server_2 : Predicate Check: The value of the predicate is " << ((Begin_Server_2->Mark()==1)&&(Request_Operation_Server->Mark()==0)&&(Start_Servers->Mark()==1)&&(ReacPulse_local->Mark()==0)&&(Begin_Success->Mark()==0)) << endl;
}

Begin_Server_2->Mark()=0;
Begin_Success->Mark()=1;

/* Reeset the flag that stopped this operation from triggerring more than one 
 * regime of reactivations for other operations through the "Start_Oper_Server" place
 */
Begin_Edge_Called->Mark() = 0;

/* Set the flag to indicate that a begin has been completed and, next, the
 * first TPCC operation is to be performed. This flag is used by the "Durations.cpp"
 * file to generate the appropriate sojourn-times for the transaction's operations.
 */
(Begin_Status[Server_ID->Mark()])[Trans_ID->Mark()]=true;


/* Set trigger to reactivate the other concurrent operations on this server */
ReacPulse_2->Mark() = ReacPulse_2->Mark() + 1;
ReacPulse_local->Mark() = 1;

/* Execute Begin Operation */
MW_ptr->Server_set_operation_result(Trans_ID->Mark(), Server_ID->Mark(), std::string("Begin success"));


/******  Sojourn-time and Data-structures reset *****/
/* Reset the Sojourn-time value for this Activity */
(Sampled_SojournTimes[Server_ID->Mark()])[Trans_ID->Mark()] = 0;

/* Decrease the current operations count by 1 */
Current_Num_of_Oper[Server_ID->Mark()] = Current_Num_of_Oper[Server_ID->Mark()] - 1;

/* Indicate that the sojourn-time for this operation will be computed for the first time on the respective Server, next time around */
(PreviousEventTime[Server_ID->Mark()])[Trans_ID->Mark()] = 0.0;
/************/

if(GV_debug_flag==22)
{
   std::cerr << "DIDERO_PC:TransactionSAN_2.cpp::IG_Begin_Server_2: The Begin edge for Client " << Trans_ID->Mark() << " on Server 2 has completed!!!" << std::endl;
}

/***** Send Trace data ******/
/* Format:: Location : Location_ID : Origin : Destination : Trans_ID : Trans_Type : Operation-type : Operation ID : Operation result : Time-stamp */

std::stringstream trace_data_stream;

trace_data_stream << std::string(" IG_Begin_Server_2 ") << std::string("Server ") << Trans_ID->Mark()<< std::string(" Server_") << Server_ID->Mark() << std::string(" Client ") << Unbounded_Trans_ID[Trans_ID->Mark()] << std::string(" ")  << (ClientObjects[Trans_ID->Mark() - 1])->get_Trans_type_names((ClientObjects[Trans_ID->Mark() - 1])->get_Trans_Profile_ID()) << std::string(" ") << MW_ptr->Server_get_operation(Trans_ID->Mark(), Server_ID->Mark()) << std::string(" ") << 0 << std::string(" ") << std::string("Begin success") << std::string(" ") << BaseModelClass::LastActionTime << std::string("\n");

if(GV_debug_flag==22)
{
   cerr << trace_data_stream.str() << endl;
}

/* Don't send trace data if the number of Simulation runs has exceeded the intended number */
if((!(GV_Experiment_Runs < Experiment_Runs_Count))&&(GV_Enable_Server_2_View_Trace==1))
{
   /* Record the number of times this activity fires (as a "sanity" check for the trace logger) */
   ActionFiringCounts[5] = ActionFiringCounts[5] + 1; 
   Trace_data_Client->send_data(trace_data_stream.str()); 
}

/****************************/
  return this;
}

/*======================IA_ReacPulse_2Activity========================*/

TransactionSAN_2SAN::IA_ReacPulse_2Activity::IA_ReacPulse_2Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("IA_ReacPulse_2",2,Deterministic, RaceEnabled, 14,3, false);
}

TransactionSAN_2SAN::IA_ReacPulse_2Activity::~IA_ReacPulse_2Activity(){
  delete[] TheDistributionParameters;
}

void TransactionSAN_2SAN::IA_ReacPulse_2Activity::LinkVariables(){
  ReacPulse_2->Register(&ReacPulse_2_Mobius_Mark);
  ReacPulse_local->Register(&ReacPulse_local_Mobius_Mark);
  Start_Servers->Register(&Start_Servers_Mobius_Mark);
  Begin_Server_2->Register(&Begin_Server_2_Mobius_Mark);
  Request_Operation_Server->Register(&Request_Operation_Server_Mobius_Mark);
  Begin_Success->Register(&Begin_Success_Mobius_Mark);
  Begin_Edge->Register(&Begin_Edge_Mobius_Mark);
  Begin_Edge_Called->Register(&Begin_Edge_Called_Mobius_Mark);
  Execute_Transaction->Register(&Execute_Transaction_Mobius_Mark);
  Oper->Register(&Oper_Mobius_Mark);
  Oper_Called->Register(&Oper_Called_Mobius_Mark);
  Oper_Server_2->Register(&Oper_Server_2_Mobius_Mark);
  Operation_Executed_Server_2->Register(&Operation_Executed_Server_2_Mobius_Mark);
  ReacPulse_Once->Register(&ReacPulse_Once_Mobius_Mark);
}

bool TransactionSAN_2SAN::IA_ReacPulse_2Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((ReacPulse_2->Mark() > 0)&&(ReacPulse_local->Mark() == 1)&&(Start_Servers->Mark()==1)));
  return NewEnabled;
}

double TransactionSAN_2SAN::IA_ReacPulse_2Activity::DeterministicParamValue(){
  return 1e-23;
  return 1.0;  // default rate if none is specified
}

double TransactionSAN_2SAN::IA_ReacPulse_2Activity::Weight(){ 
  return 1;
}

bool TransactionSAN_2SAN::IA_ReacPulse_2Activity::ReactivationPredicate(){ 
  return false;
}

bool TransactionSAN_2SAN::IA_ReacPulse_2Activity::ReactivationFunction(){ 
  return false;
}

double TransactionSAN_2SAN::IA_ReacPulse_2Activity::SampleDistribution(){
  return 1e-23;
}

double* TransactionSAN_2SAN::IA_ReacPulse_2Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int TransactionSAN_2SAN::IA_ReacPulse_2Activity::Rank(){
  return 1;
}

BaseActionClass* TransactionSAN_2SAN::IA_ReacPulse_2Activity::Fire(){
  if(GV_debug_flag==23)
{
   cerr << "IG_ReacPulse_2 : Predicate Check: The value of the predicate is " << ((ReacPulse_2->Mark() == 1)&&(ReacPulse_local->Mark() == 1)&&(Start_Servers->Mark()==1)) << endl;
   bool SAN_predicate_check = !((!((Begin_Server_2->Mark()==1)&&(Request_Operation_Server->Mark()==0)&&(Start_Servers->Mark()==1)&&(ReacPulse_local->Mark()==0)&&(Begin_Success->Mark()==0)))&&(!((Begin_Edge->Mark()>0)&&(Begin_Edge_Called->Mark()==1)&&(Begin_Server_2->Mark() == 0)&&(Request_Operation_Server->Mark() == 0)&&(Begin_Success->Mark()==0)&&(ReacPulse_local->Mark()==0)))&&(!((Execute_Transaction->Mark()==1)&&(Oper->Mark()==0)&&(Request_Operation_Server->Mark()==1)&&(Start_Servers->Mark()==1)&&(Oper_Called->Mark()==0)&&(ReacPulse_local->Mark()==0)))&&(!((Oper_Server_2->Mark()==0)&&(Oper->Mark()>0)&&(Start_Servers->Mark()==1)&&(Oper_Called->Mark()==1)&&(Request_Operation_Server->Mark()==1)&&(ReacPulse_local->Mark()==0)))&&(!((Execute_Transaction->Mark()==1)&&(Request_Operation_Server->Mark()==1)&&(Start_Servers->Mark()==1)&&(ReacPulse_local->Mark() == 0)&&(Oper_Server_2->Mark() == 1))));
   cerr << "IG_ReacPulse_2 : Predicate Check: The value of all other predicates is " << SAN_predicate_check << endl;
}

ReacPulse_2->Mark() = ReacPulse_2->Mark() - 1;
ReacPulse_local->Mark() = 0;

/* Signal to the respective Client the result of the currently executed operation is ready */
Request_Operation_Server->Mark() = 0;
Operation_Executed_Server_2->Mark() = 1;
ReacPulse_Once->Mark()=0;

  return this;
}

/*======================IA_Begin_EdgeActivity========================*/

TransactionSAN_2SAN::IA_Begin_EdgeActivity::IA_Begin_EdgeActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("IA_Begin_Edge",3,Deterministic, RaceEnabled, 8,6, false);
}

TransactionSAN_2SAN::IA_Begin_EdgeActivity::~IA_Begin_EdgeActivity(){
  delete[] TheDistributionParameters;
}

void TransactionSAN_2SAN::IA_Begin_EdgeActivity::LinkVariables(){
  Begin_Edge->Register(&Begin_Edge_Mobius_Mark);
  Begin_Edge_Called->Register(&Begin_Edge_Called_Mobius_Mark);
  Begin_Server_2->Register(&Begin_Server_2_Mobius_Mark);
  Request_Operation_Server->Register(&Request_Operation_Server_Mobius_Mark);
  Begin_Success->Register(&Begin_Success_Mobius_Mark);
  ReacPulse_local->Register(&ReacPulse_local_Mobius_Mark);
  Server_ID->Register(&Server_ID_Mobius_Mark);
  Trans_ID->Register(&Trans_ID_Mobius_Mark);
}

bool TransactionSAN_2SAN::IA_Begin_EdgeActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Begin_Edge->Mark()>0)&&(Begin_Edge_Called->Mark()==1)&&(Begin_Server_2->Mark() == 0)&&(Request_Operation_Server->Mark() == 0)&&(Begin_Success->Mark()==0)&&(ReacPulse_local->Mark()==0)
/* Check if there is a token to be grabbed, this transaction thread has 
   been enabled by the Client, and the begin edge of this transaction has
   not been processed yet 
*/));
  return NewEnabled;
}

double TransactionSAN_2SAN::IA_Begin_EdgeActivity::DeterministicParamValue(){
  return 1e-23;
  return 1.0;  // default rate if none is specified
}

double TransactionSAN_2SAN::IA_Begin_EdgeActivity::Weight(){ 
  return 1;
}

bool TransactionSAN_2SAN::IA_Begin_EdgeActivity::ReactivationPredicate(){ 
  return false;
}

bool TransactionSAN_2SAN::IA_Begin_EdgeActivity::ReactivationFunction(){ 
  return false;
}

double TransactionSAN_2SAN::IA_Begin_EdgeActivity::SampleDistribution(){
  return 1e-23;
}

double* TransactionSAN_2SAN::IA_Begin_EdgeActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int TransactionSAN_2SAN::IA_Begin_EdgeActivity::Rank(){
  return 1;
}

BaseActionClass* TransactionSAN_2SAN::IA_Begin_EdgeActivity::Fire(){
  if(GV_debug_flag==20)
{
   cerr << "IG_Begin_Edge : Predicate Check: The value of the predicate is " << ((Begin_Edge->Mark()>0)&&(Begin_Edge_Called->Mark()==1)&&(Begin_Server_2->Mark() == 0)&&(Request_Operation_Server->Mark() == 0)&&(Begin_Success->Mark()==0)&&(ReacPulse_local->Mark()==0)) << endl;
}


/* All concurrent operations on the server have been reactivated,
   so grab a token and ensure another token cannot be grabbed for 
   this transaction
 */
Begin_Edge->Mark()=Begin_Edge->Mark()-1;

/* Execute the Begin Operation */
Begin_Server_2->Mark()=1;

/* Set the flag to indicate that the Begin Edge has not been performed for this Transaction.
 * This flag is used by the "Durations.cpp"
 * file to generate the appropriate sojourn-times for the transaction's operations.
 */
if((Begin_Status[Server_ID->Mark()])[Trans_ID->Mark()]==true)
{
    (Begin_Status[Server_ID->Mark()])[Trans_ID->Mark()]=false;
}


/**** Sojourn-time data and data-structures *****/

/* Reset the Sojourn-time value for this Activity */
(Sampled_SojournTimes[Server_ID->Mark()])[Trans_ID->Mark()] = 0;

/* Increase the current operations count by 1 */
Current_Num_of_Oper[Server_ID->Mark()] = Current_Num_of_Oper[Server_ID->Mark()] + 1;

/* Indicate that the sojourn-time for this operation will be computed for the first time on the respective Server, next time around */
(PreviousEventTime[Server_ID->Mark()])[Trans_ID->Mark()] = 0.0;

/**************************/


/***** Send Trace data ******/
/* Format:: Location : Location_ID : Origin : Destination : Trans_ID : Trans_Type : Operation-type : Operation ID : Operation result : Time-stamp */

std::stringstream trace_data_stream;

trace_data_stream << std::string(" IG_Begin_Edge ") << std::string("Server ") << Trans_ID->Mark() << std::string(" Server_") << Server_ID->Mark() << std::string(" Client ") << Unbounded_Trans_ID[Trans_ID->Mark()] << std::string(" ")  << (ClientObjects[Trans_ID->Mark() - 1])->get_Trans_type_names((ClientObjects[Trans_ID->Mark() - 1])->get_Trans_Profile_ID()) << std::string(" ") << MW_ptr->Server_get_operation(Trans_ID->Mark(), Server_ID->Mark()) << std::string(" ") << MW_ptr->Server_get_Trans_oper_ID(Trans_ID->Mark(),Server_ID->Mark()) << std::string(" ") << std::string("Begin") << std::string(" ") << BaseModelClass::LastActionTime << std::string("\n");

if(GV_debug_flag==15)
{
   cerr << trace_data_stream.str() << endl;
}

/* Don't send trace data if the number of Simulation runs has exceeded the intended number */
if((!(GV_Experiment_Runs < Experiment_Runs_Count))&&(GV_Enable_Server_2_View_Trace==1))
{
   /* Record the number of times this activity fires (as a "sanity" check for the trace logger) */
   ActionFiringCounts[5] = ActionFiringCounts[5] + 1; 
   Trace_data_Client->send_data(trace_data_stream.str()); 
}

/****************************/

  return this;
}

/*======================IA_OperActivity========================*/

TransactionSAN_2SAN::IA_OperActivity::IA_OperActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("IA_Oper",4,Deterministic, RaceEnabled, 8,6, false);
}

TransactionSAN_2SAN::IA_OperActivity::~IA_OperActivity(){
  delete[] TheDistributionParameters;
}

void TransactionSAN_2SAN::IA_OperActivity::LinkVariables(){
  Oper_Server_2->Register(&Oper_Server_2_Mobius_Mark);
  Oper->Register(&Oper_Mobius_Mark);
  Start_Servers->Register(&Start_Servers_Mobius_Mark);
  Oper_Called->Register(&Oper_Called_Mobius_Mark);
  Request_Operation_Server->Register(&Request_Operation_Server_Mobius_Mark);
  ReacPulse_local->Register(&ReacPulse_local_Mobius_Mark);
  Server_ID->Register(&Server_ID_Mobius_Mark);
  Trans_ID->Register(&Trans_ID_Mobius_Mark);
}

bool TransactionSAN_2SAN::IA_OperActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Oper_Server_2->Mark()==0)&&(Oper->Mark()>0)&&(Start_Servers->Mark()==1)&&(Oper_Called->Mark()==1)&&(Request_Operation_Server->Mark()==1)&&(ReacPulse_local->Mark()==0)));
  return NewEnabled;
}

double TransactionSAN_2SAN::IA_OperActivity::DeterministicParamValue(){
  return 1e-23;
  return 1.0;  // default rate if none is specified
}

double TransactionSAN_2SAN::IA_OperActivity::Weight(){ 
  return 1;
}

bool TransactionSAN_2SAN::IA_OperActivity::ReactivationPredicate(){ 
  return false;
}

bool TransactionSAN_2SAN::IA_OperActivity::ReactivationFunction(){ 
  return false;
}

double TransactionSAN_2SAN::IA_OperActivity::SampleDistribution(){
  return 1e-23;
}

double* TransactionSAN_2SAN::IA_OperActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int TransactionSAN_2SAN::IA_OperActivity::Rank(){
  return 1;
}

BaseActionClass* TransactionSAN_2SAN::IA_OperActivity::Fire(){
  if(GV_debug_flag==20)
{
   cerr << "IG_Oper: Predicate Check: The value of the predicate is " << ((Oper_Server_2->Mark()==0)&&(Oper->Mark()==1)&&(Start_Servers->Mark()==1)&&(Oper_Called->Mark()==1)&&(Request_Operation_Server->Mark()==1)&&(ReacPulse_local->Mark()==0)) << endl;
}

Oper->Mark() = Oper->Mark() - 1;
Oper_Server_2->Mark() = 1;

/**** Sojourn-time data and data-structures *****/

/* Reset the Sojourn-time value for this Activity */
(Sampled_SojournTimes[Server_ID->Mark()])[Trans_ID->Mark()] = 0;

/* Increase the current operations count by 1 */
Current_Num_of_Oper[Server_ID->Mark()] = Current_Num_of_Oper[Server_ID->Mark()] + 1;

/* Indicate that the sojourn-time for this operation will be computed for the first time on the respective Server */
(PreviousEventTime[Server_ID->Mark()])[Trans_ID->Mark()] = 0.0;

/**************************/


/***** Send Trace data ******/
/* Format:: Location : Location_ID : Origin : Destination : Trans_ID : Trans_Type : Operation_ID : Operation-type : Time-stamp */

std::stringstream trace_data_stream;

trace_data_stream << std::string(" IG_Oper ") << std::string("Server ") << Trans_ID->Mark() << std::string(" Server_") << Server_ID->Mark() << std::string(" Client ") << Unbounded_Trans_ID[Trans_ID->Mark()] << std::string(" ")  << (ClientObjects[Trans_ID->Mark() - 1])->get_Trans_type_names((ClientObjects[Trans_ID->Mark() - 1])->get_Trans_Profile_ID()) << std::string(" ") << MW_ptr->Server_get_Trans_oper_ID(Trans_ID->Mark(),Server_ID->Mark()) << std::string(" ") << MW_ptr->Server_get_operation(Trans_ID->Mark(), Server_ID->Mark()) << std::string(" ") << BaseModelClass::LastActionTime << std::string("\n");

if(GV_debug_flag==15)
{
   cerr << trace_data_stream.str() << endl;
}

/* Don't send trace data if the number of Simulation runs has exceeded the intended number */
if((!(GV_Experiment_Runs < Experiment_Runs_Count))&&(GV_Enable_Server_2_View_Trace==1))
{
   /* Record the number of times this activity fires (as a "sanity" check for the trace logger) */
   ActionFiringCounts[5] = ActionFiringCounts[5] + 1; 
   Trace_data_Client->send_data(trace_data_stream.str()); 
}


/****************************/
  return this;
}

