#include "Composed/Client_Server/Client_ServerRJ.h"
char * Client_ServerRJ__SharedNames[] = {"Init_Blocking_Ptrs", "Number_of_Clients", "Start_Client_Servers"};

Client_ServerRJ::Client_ServerRJ():Join("DIDERO_PC_PerfEvalModel", 2, 3,Client_ServerRJ__SharedNames) {
  Rep_Client_DivSQL = new Client_ServerRJ__Rep_Client_DivSQL();
  ModelArray[0] = (BaseModelClass*) Rep_Client_DivSQL;
  ModelArray[0]->DefineName("Rep_Client_DivSQL");
  Initializer = new InitializerSAN();
  ModelArray[1] = (BaseModelClass*) Initializer;
  ModelArray[1]->DefineName("Initializer");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    Init_Blocking_Ptrs = new Place("Init_Blocking_Ptrs");
    addSharedPtr(Init_Blocking_Ptrs, "Init_Blocking_Ptrs" );
    if (Rep_Client_DivSQL->NumStateVariables > 0) {
      Init_Blocking_Ptrs->ShareWith(Rep_Client_DivSQL->Init_Blocking_Ptrs);
      addSharingInfo(Rep_Client_DivSQL->Init_Blocking_Ptrs, Init_Blocking_Ptrs, Rep_Client_DivSQL);
    }
    if (Initializer->NumStateVariables > 0) {
      Init_Blocking_Ptrs->ShareWith(Initializer->Init_Blocking_Pointers);
      addSharingInfo(Initializer->Init_Blocking_Pointers, Init_Blocking_Ptrs, Initializer);
    }

    //Shared variable 1
    Number_of_Clients = new Place("Number_of_Clients");
    addSharedPtr(Number_of_Clients, "Number_of_Clients" );
    if (Rep_Client_DivSQL->NumStateVariables > 0) {
      Number_of_Clients->ShareWith(Rep_Client_DivSQL->Number_of_Clients);
      addSharingInfo(Rep_Client_DivSQL->Number_of_Clients, Number_of_Clients, Rep_Client_DivSQL);
    }
    if (Initializer->NumStateVariables > 0) {
      Number_of_Clients->ShareWith(Initializer->Client_Trans_IDs);
      addSharingInfo(Initializer->Client_Trans_IDs, Number_of_Clients, Initializer);
    }

    //Shared variable 2
    Start_Client_Servers = new Place("Start_Client_Servers");
    addSharedPtr(Start_Client_Servers, "Start_Client_Servers" );
    if (Rep_Client_DivSQL->NumStateVariables > 0) {
      Start_Client_Servers->ShareWith(Rep_Client_DivSQL->Start_Client_Servers);
      addSharingInfo(Rep_Client_DivSQL->Start_Client_Servers, Start_Client_Servers, Rep_Client_DivSQL);
    }
    if (Initializer->NumStateVariables > 0) {
      Start_Client_Servers->ShareWith(Initializer->Start_Clients_and_Servers);
      addSharingInfo(Initializer->Start_Clients_and_Servers, Start_Client_Servers, Initializer);
    }

  }

  Setup();
}

Client_ServerRJ::~Client_ServerRJ() {
  if (!AllChildrenEmpty()) {
    delete Init_Blocking_Ptrs;
    delete Number_of_Clients;
    delete Start_Client_Servers;
  }
  delete Rep_Client_DivSQL;
  delete Initializer;
}
