#ifndef Client_ServerRJ__DivSQL_H_
#define Client_ServerRJ__DivSQL_H_
#include "udf/DIDERO_PC.h"
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Atomic/DivSQL/DivSQLSAN.h"
#include "Atomic/TransactionSAN_1/TransactionSAN_1SAN.h"
#include "Atomic/TransactionSAN_2/TransactionSAN_2SAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"
extern short GV_debug_flag;
extern short GV_Number_of_Clients_and_Trans;
extern int GV_Efficient_Oper_Capacity_Server_1;
extern int GV_Efficient_Oper_Capacity_Server_2;
extern double GV_ExpScaling_LowerBound;

class Client_ServerRJ__DivSQL: public Join {
 public:
  DivSQLSAN * DivRep;
  TransactionSAN_1SAN * TransactionSAN_1;
  TransactionSAN_2SAN * TransactionSAN_2;
  Place * All_Server_1_Trans_CommitSuccess_1;
  Place * All_Server_1_Trans_DivREPTrans1;
  Place * All_Server_2_Trans_CommitSuccess_1;
  Place * All_Server_2_Trans_DivREPTrans2;
  Place * Begin_Server_1;
  Place * Begin_Server_2;
  Place * Begin_Success_Server_1;
  Place * Begin_Success_Server_2;
  Place * DivSQL_ID;
  Place * End_Oper_Server_1;
  Place * End_Oper_Server_2;
  Place * Init_Blocking_Pointers;
  Place * Operation_Executed_Client;
  Place * Operation_Executed_ServerMW_1;
  Place * Operation_Executed_ServerMW_2;
  Place * Request_Operation_Client;
  Place * Request_Operation_ServerMW_1;
  Place * Request_Operation_ServerMW_2;
  Place * Start_Oper_Server_1;
  Place * Start_Oper_Server_2;
  Place * Start_Servers_MW;
  Place * Trans_Oper_Server_1;
  Place * Trans_Oper_Server_2;

  Client_ServerRJ__DivSQL();
  ~Client_ServerRJ__DivSQL();
};

#endif
