
#ifndef DIDERO_PC_DefaultRangeSTUDY_H_
#define DIDERO_PC_DefaultRangeSTUDY_H_

#include "Reward/Durations_of_Requests_and_Operations/Durations_of_Requests_and_OperationsPVNodes.h"
#include "Reward/Durations_of_Requests_and_Operations/Durations_of_Requests_and_OperationsPVModel.h"
#include "Cpp/Study/BaseStudyClass.hpp"

extern double Choose_Cust_using_ID;
extern bool GV_Couple_Server_Trans_Durations;
extern int GV_Cust_per_District;
extern bool GV_DefaultResidualTimes;
extern int GV_Efficient_Oper_Capacity_Server_1;
extern int GV_Efficient_Oper_Capacity_Server_2;
extern short GV_Enable_Client_View_Trace;
extern short GV_Enable_Server_1_View_Trace;
extern short GV_Enable_Server_2_View_Trace;
extern double GV_ExpScaling_LowerBound;
extern int GV_Experiment_Runs;
extern bool GV_IntraTransDepBurstiness;
extern bool GV_IntraTransaction_Dependence;
extern short GV_Num_Dist_per_Warehouses;
extern short GV_Number_of_Clients_and_Trans;
extern short GV_Number_of_Warehouses;
extern float GV_Oper_Dur_Raw_Data_Scaling;
extern double GV_ReacModel_ExpScaling;
extern double GV_ReacModel_PolyPower;
extern double GV_Server_1_Prob_of_IntraTransDependence;
extern bool GV_Server_1_enabled;
extern double GV_Server_2_Prob_of_IntraTransDependence;
extern bool GV_Server_2_enabled;
extern bool GV_Step_Inverse_Transform;
extern bool GV_TPCC;
extern short GV_debug_flag;
extern double Prob_of_Bad_Cust;
extern double Prob_of_Cust_ID;
extern double Prob_of_Delivery;
extern double Prob_of_Local_Orderlines;
extern double Prob_of_NewOrder;
extern double Prob_of_Orderstatus;
extern double Prob_of_Payment;
extern double Prob_of_Stocklevel;

class DIDERO_PC_DefaultRangeStudy : public BaseStudyClass {
public:

DIDERO_PC_DefaultRangeStudy();
~DIDERO_PC_DefaultRangeStudy();

private:

double *Choose_Cust_using_IDValues;
bool *GV_Couple_Server_Trans_DurationsValues;
int *GV_Cust_per_DistrictValues;
bool *GV_DefaultResidualTimesValues;
int *GV_Efficient_Oper_Capacity_Server_1Values;
int *GV_Efficient_Oper_Capacity_Server_2Values;
short *GV_Enable_Client_View_TraceValues;
short *GV_Enable_Server_1_View_TraceValues;
short *GV_Enable_Server_2_View_TraceValues;
double *GV_ExpScaling_LowerBoundValues;
int *GV_Experiment_RunsValues;
bool *GV_IntraTransDepBurstinessValues;
bool *GV_IntraTransaction_DependenceValues;
short *GV_Num_Dist_per_WarehousesValues;
short *GV_Number_of_Clients_and_TransValues;
short *GV_Number_of_WarehousesValues;
float *GV_Oper_Dur_Raw_Data_ScalingValues;
double *GV_ReacModel_ExpScalingValues;
double *GV_ReacModel_PolyPowerValues;
double *GV_Server_1_Prob_of_IntraTransDependenceValues;
bool *GV_Server_1_enabledValues;
double *GV_Server_2_Prob_of_IntraTransDependenceValues;
bool *GV_Server_2_enabledValues;
bool *GV_Step_Inverse_TransformValues;
bool *GV_TPCCValues;
short *GV_debug_flagValues;
double *Prob_of_Bad_CustValues;
double *Prob_of_Cust_IDValues;
double *Prob_of_DeliveryValues;
double *Prob_of_Local_OrderlinesValues;
double *Prob_of_NewOrderValues;
double *Prob_of_OrderstatusValues;
double *Prob_of_PaymentValues;
double *Prob_of_StocklevelValues;

void SetValues_Choose_Cust_using_ID();
void SetValues_GV_Couple_Server_Trans_Durations();
void SetValues_GV_Cust_per_District();
void SetValues_GV_DefaultResidualTimes();
void SetValues_GV_Efficient_Oper_Capacity_Server_1();
void SetValues_GV_Efficient_Oper_Capacity_Server_2();
void SetValues_GV_Enable_Client_View_Trace();
void SetValues_GV_Enable_Server_1_View_Trace();
void SetValues_GV_Enable_Server_2_View_Trace();
void SetValues_GV_ExpScaling_LowerBound();
void SetValues_GV_Experiment_Runs();
void SetValues_GV_IntraTransDepBurstiness();
void SetValues_GV_IntraTransaction_Dependence();
void SetValues_GV_Num_Dist_per_Warehouses();
void SetValues_GV_Number_of_Clients_and_Trans();
void SetValues_GV_Number_of_Warehouses();
void SetValues_GV_Oper_Dur_Raw_Data_Scaling();
void SetValues_GV_ReacModel_ExpScaling();
void SetValues_GV_ReacModel_PolyPower();
void SetValues_GV_Server_1_Prob_of_IntraTransDependence();
void SetValues_GV_Server_1_enabled();
void SetValues_GV_Server_2_Prob_of_IntraTransDependence();
void SetValues_GV_Server_2_enabled();
void SetValues_GV_Step_Inverse_Transform();
void SetValues_GV_TPCC();
void SetValues_GV_debug_flag();
void SetValues_Prob_of_Bad_Cust();
void SetValues_Prob_of_Cust_ID();
void SetValues_Prob_of_Delivery();
void SetValues_Prob_of_Local_Orderlines();
void SetValues_Prob_of_NewOrder();
void SetValues_Prob_of_Orderstatus();
void SetValues_Prob_of_Payment();
void SetValues_Prob_of_Stocklevel();

void PrintGlobalValues(int);
void *GetGVValue(char *TheGVName);
void OverrideGVValue(char *TheGVName, void *TheGVValue);
void SetGVs(int expnum);
PVModel *GetPVModel(bool expandTimeArrays);
};

#endif

