/* 
 * File:   Client_Interface.h
 * Author: kizito
 *
 * Created on 23 October 2013, 15:36
 */

#ifndef CLIENT_INTERFACE_H
#define	CLIENT_INTERFACE_H

#ifdef MY_COMPILE_DLL
#define MY_DECLSPEC __declspec(dllexport)
#else
#define MY_DECLSPEC __declspec(dllimport)
#endif


#include <iostream>
#include <string>

using namespace std;

class MY_DECLSPEC Client_Interface
{

        public:
        
        virtual ~Client_Interface(){};
        
        virtual int set_Client_ID(int) = 0;
        virtual int get_Client_ID() = 0;
        /* The next method will randomly choose a transaction profile according to TPCC */
        virtual int begin_transaction() = 0;
        
        virtual int get_flat_Trans_Oper_index(int,int) = 0;
        virtual int get_Trans_Profile_ID() = 0;
        virtual int get_Trans_Profile_oper_ID() = 0;
        virtual unsigned int get_Shared_Data_ID() = 0;
        virtual int set_Shared_Data_ID(unsigned int) = 0;        
        virtual std::string get_Shared_Data_Operation() = 0;
        virtual int set_Shared_Data_Operation(std::string) = 0;        
        virtual std::string get_Shared_Data_Key() = 0;
        virtual int set_Shared_Data_Key(std::string) = 0;
        virtual int set_Oper_Exec_Status(std::string) = 0;
        virtual std::string get_Oper_Exec_Status() = 0;
        virtual std::string get_Trans_type_names(int) = 0;
        
        /* This  method will randomly choose the transaction profile and operations thereof with each
         * subsequent call.
         *          
         */
        virtual string Transaction_Instance() = 0;
        
};

    typedef Client_Interface* (*create_Client)(int,int,int,int,char*,short,double,double,double,double,double,double,double,double,double);               /*There should be a method, implemented in the same source file as the plugin
                                                                     class definition (the most specialised/"derived" class in the
                                                                     *plugin hierarchy), whose prototype matches
                                                                     this typedef and the purpose of which is to instantiate an
                                                                     object of the class--type that is "highest"/leaf/"most specialised"
                                                                     in the hierarchy*/
    typedef void (*destroy_Client)(Client_Interface*);
    

#endif	/* CLIENT_INTERFACE_H */
