/* Local variable to store results */
std::string result("");
int Server_ID = Server_Result_ID->Mark();

/* Reset the Server_return_ID flag */
Server_Result_ID->Mark()=0;

/* Compute the boolean to indicate if both servers have, simultaneously, returned their results */
int concurrent_results = Operation_Executed_Server_1->Mark()*Operation_Executed_Server_2->Mark();

if(GV_debug_flag==5)
{
    if(concurrent_results==1)
    {
         std::cerr << "DIDERO_PC:DivSQL.cpp:: Results for Client " << MW_ID->Mark() <<" have been returned by both Servers, simultaneously !!!" << std::endl;
    }else
    {
         std::cerr << "DIDERO_PC:DivSQL.cpp:: Results for Client " << MW_ID->Mark() <<" have NOT been returned by both Servers, simultaneously !!!" << std::endl;
    }
}

result = DivSQL_Results(MW_ID->Mark(),Server_ID, Server_1_Waiting_For_Client->Mark(), Server_2_Waiting_For_Client->Mark(), Waiting_for_Slower_Server->Mark(), Waiting_for_Faster_Server->Mark());

/* Reset the "Waiting_for_Faster_Server->Mark()" place, if already set */
if(Waiting_for_Faster_Server->Mark()!=0)
{
	Waiting_for_Faster_Server->Mark() = 0;
}

/* The possible "result" messages to handle, apart from forwarding the faster
response to the client, are:

"Wait for slower Server"
"Wait for faster Server"
"Exception"
"Activate slower Server"
"Wait for Client"
"Activate for Abort"

*/

//if(MW_ID->Mark()==5)
if(GV_debug_flag==5)
{
     std::cerr << "DIDERO_PC:DivSQL.cpp:: The next operation for Client " << MW_ID->Mark() <<" , implied by the result that has just been returned, is " << result << "!!!" << std::endl;
}

if(result.compare(std::string("Commit or Abort success"))==0)
{
   if(GV_debug_flag==5)
   {
        std::cerr << "DIDERO_PC:DivSQL.cpp:: " << ClientObjects[MW_ID->Mark()-1]->get_Oper_Exec_Status() << " has successfully been performed on both Servers for Client" << MW_ID->Mark() <<"!!!" << std::endl;
   }

   /* Reset the transaction progress counts on each of the servers */
   (Server_oper_index[MW_ID->Mark()])[1] = 0;
   (Server_oper_index[MW_ID->Mark()])[2] = 0;
 
   /* Reset the buffers of results and transaction operations for each server */
   (Trans_Oper_Replica_Results[MW_ID->Mark()]).clear();
   (Oper_Data_for_Replicas[MW_ID->Mark()]).clear();

   /* Set the appropriate Mobius places */
   Operation_Executed_Server_1->Mark() = 0;
   Operation_Executed_Server_2->Mark() = 0;
   Server_1_Waiting_For_Client->Mark() = 1;
   Server_2_Waiting_For_Client->Mark() = 1;
   
   Operation_Executed_Client->Mark() = 1;

}else if(result.compare(std::string("Wait for slower Server"))==0)
{
	if(Server_ID==1)
	{
           Operation_Executed_Server_1->Mark() = 0;
		   Server_1_Waiting_For_Client->Mark() = 1;
		   
	}else if(Server_ID==2)
	{
           Operation_Executed_Server_2->Mark() = 0;
		   Server_2_Waiting_For_Client->Mark() = 1;
	}

	
    Waiting_for_Slower_Server->Mark() = 1;

}else if(result.compare(std::string("Wait for faster Server"))==0)
{
	if(Server_ID==1)
	{
           Operation_Executed_Server_1->Mark() = 0;
		   Server_1_Waiting_For_Client->Mark() = 1;
	
	}else if(Server_ID==2)
	{
           Operation_Executed_Server_2->Mark() = 0;
		   Server_2_Waiting_For_Client->Mark() = 1;
	}

	/* If the faster server is already waiting for the Slower Server then don't keep it waiting */
	if(Waiting_for_Slower_Server->Mark() != 0)
    {
	   /* Indicate to the middleware that both Servers are waiting for the Client */
	   Server_1_Waiting_For_Client->Mark() = 1;
	   Server_2_Waiting_For_Client->Mark() = 1;
	   
	   /* Set Abort flags for both Transactions, reset places and return result to Client */
	   Server_1->set_Abort(MW_ID->Mark(),true);
	   Server_2->set_Abort(MW_ID->Mark(),true);

		/* Reset the "Wait for faster/slower server flags " */
		Waiting_for_Slower_Server->Mark()=0;
		Waiting_for_Faster_Server->Mark()=0;

        ClientObjects[MW_ID->Mark()-1]->set_Oper_Exec_Status(std::string("Abort"));		
    
		/* Let the client know that an abort should take place */
		Operation_Executed_Client->Mark() = 1;	
	
	}else
	{
		/* Let the faster Server know it is being waited for */
		Waiting_for_Faster_Server->Mark() = Server_ID;
	}
}else if(result.compare(std::string("Exception"))==0)
{
   if(GV_debug_flag==10)
   {
      std::cerr << "DIDERO_PC:DivSQL.cpp:: An exception has been raised for Client " << MW_ID->Mark() << " to Abort!!!!!" << std::endl;
   }

   /* Indicate to the middleware that both Servers are waiting for the Client */
   Server_1_Waiting_For_Client->Mark() = 1;
   Server_2_Waiting_For_Client->Mark() = 1;
   
   /* Set Abort flags for both Transactions, reset places and return result to Client */
   Server_1->set_Abort(MW_ID->Mark(),true);
   Server_2->set_Abort(MW_ID->Mark(),true);

	/* Reset the "Wait for faster/slower server flags " */
	Waiting_for_Slower_Server->Mark()=0;
	Waiting_for_Faster_Server->Mark()=0;
   
   if(Server_ID==1)
   {
      Operation_Executed_Server_1->Mark() = 0; 
   }else
   {
      Operation_Executed_Server_2->Mark() = 0; 
   }

   Operation_Executed_Client->Mark() = 1;

}else if(result.compare(std::string("Activate slower Server"))==0)
{
    /* The Servers agree on the most recent pair of results. So, tell the slower 
       Server to continue with executing it's next operation.
     */

   /* Check to see if the faster server is waiting to commit and the slower server
      is also ready to commit */ 
    if(((((Oper_Data_for_Replicas[MW_ID->Mark()])[(Oper_Data_for_Replicas[MW_ID->Mark()]).size()])[0]).compare(std::string("Commit"))==0)&&( ((Oper_Data_for_Replicas[MW_ID->Mark()]).size() - Server_oper_index[MW_ID->Mark()][1] ) == 1) && ( ((Oper_Data_for_Replicas[MW_ID->Mark()]).size() - Server_oper_index[MW_ID->Mark()][2] ) == 1))
    {
		if(GV_debug_flag==13)
		{
			std::cerr << "DIDERO_PC:DivSQL.cpp::Activate slower Server::Carry out Commit on Both Servers " << std::endl;	
		}
	   
	   /*Activate the "request" timed activity to instigate commits on both Servers */
       if(Waiting_for_Slower_Server->Mark() != 0)
       {
          Waiting_for_Slower_Server->Mark() = 0;
       }
	   
		Server_1_Waiting_For_Client->Mark() = 1;
		Server_2_Waiting_For_Client->Mark() = 1;		
		Slower_Server->Mark()=Server_ID;	   
       
       if(Server_ID==1)
       {
          Operation_Executed_Server_1->Mark() = 0; 
       }else
       {
          Operation_Executed_Server_2->Mark() = 0;
       }
    }else
    {
		/* The next operation has arrived and is already being operated on by the other Server */
		if(( ((Oper_Data_for_Replicas[MW_ID->Mark()]).size() - Server_oper_index[MW_ID->Mark()][Server_ID] ) >= 1)&&((((Oper_Data_for_Replicas[MW_ID->Mark()])[(Oper_Data_for_Replicas[MW_ID->Mark()]).size()])[0]).compare(std::string("Commit"))!=0))
		{			
		   /* The next operation should be carried out by the slower server */
		   if(Server_ID==1)
		   {

				if(GV_debug_flag==13)
				{
					std::cerr << "DIDERO_PC:DivSQL.cpp::Activate slower Server::Carry out next operation for Client " << MW_ID->Mark() << " on Server " << Server_ID << std::endl;
				}
			  Operation_Executed_Server_1->Mark() = 0;
			  Request_Operation_Server_1->Mark() = 1;			  
			  Current_Num_of_Oper[1] = Current_Num_of_Oper[1] + 1;
			  Trans_Oper_Server_1->Mark()=1;
			  Start_Oper_Server_1->Mark()=1;
			  
		   }else
		   {
				if(GV_debug_flag==13)
				{
					std::cerr << "DIDERO_PC:DivSQL.cpp::Activate slower Server::Carry out next operation for Client " << MW_ID->Mark() << " on Server " << Server_ID << std::endl;
				}		   
		   
			  Operation_Executed_Server_2->Mark() = 0;
			  Request_Operation_Server_2->Mark() = 1;
			  Current_Num_of_Oper[2] = Current_Num_of_Oper[2] + 1;
			  Trans_Oper_Server_2->Mark()=1;
			  Start_Oper_Server_2->Mark()=1;
		   }
		}else if(( ((Oper_Data_for_Replicas[MW_ID->Mark()]).size() - Server_oper_index[MW_ID->Mark()][Server_ID] ) > 1)&&((((Oper_Data_for_Replicas[MW_ID->Mark()])[(Oper_Data_for_Replicas[MW_ID->Mark()]).size()])[0]).compare(std::string("Commit"))==0))
		{
			if(GV_debug_flag==5)
			{
				std::cerr << "DIDERO_PC:DivSQL.cpp::Activate slower Server::Carry out next operation " << std::endl;		
			}
		   
		   /* The next operation should be carried out by the slower server */
		   if(Server_ID==1)
		   {
				if(GV_debug_flag==13)
				{
					std::cerr << "DIDERO_PC:DivSQL.cpp::Activate slower Server::Carry out next operation for Client " << MW_ID->Mark() << " on Server " << Server_ID << std::endl;
				}		   
			  Operation_Executed_Server_1->Mark() = 0;
			  Request_Operation_Server_1->Mark() = 1;
			  Current_Num_of_Oper[1] = Current_Num_of_Oper[1] + 1;
			  Trans_Oper_Server_1->Mark()=1;	 
			  Start_Oper_Server_1->Mark()=1; 	
		   }else
		   {
				if(GV_debug_flag==13)
				{
					std::cerr << "DIDERO_PC:DivSQL.cpp::Activate slower Server::Carry out next operation for Client " << MW_ID->Mark() << " on Server " << Server_ID << std::endl;
				}		   
			  Operation_Executed_Server_2->Mark() = 0;
			  Request_Operation_Server_2->Mark() = 1;
			  Current_Num_of_Oper[2] = Current_Num_of_Oper[2] + 1;
			  Trans_Oper_Server_2->Mark()=1;
			  Start_Oper_Server_2->Mark()=1;
			}			
		}else
		{
			if(GV_debug_flag==5)
			{
				std::cerr << "DIDERO_PC:DivSQL.cpp::Activate slower Server::Wait for Client " << std::endl;
			}
			
			/* Wait for the Client to tell the Middleware what to do next */
			if(Server_ID==1)
			{
				Operation_Executed_Server_1->Mark() = 0; 
				Server_1_Waiting_For_Client->Mark() = 1;
			}else
			{
				Operation_Executed_Server_2->Mark() = 0;
				Server_2_Waiting_For_Client->Mark() = 1;				
			}
		}
    
    }     

}else if(result.compare(std::string("Activate for Abort"))==0)
{
    /* Stop Servers from waiting for each other */
    if(Waiting_for_Slower_Server->Mark() == 1)
    {
		Waiting_for_Slower_Server->Mark() = 0;
    }
       
   /* Indicate to the middleware that both Servers are waiting for the Client */
   Server_1_Waiting_For_Client->Mark() = 1;
   Server_2_Waiting_For_Client->Mark() = 1;
   
   /* Activate the "Request_Oper" Timed-Activity */
   Slower_Server->Mark() = 1;
   
   /* Set Abort flags for both Transactions, reset places and return result to Client */
   Server_1->set_Abort(MW_ID->Mark(),true);
   Server_2->set_Abort(MW_ID->Mark(),true);

   if(Server_ID==1)
   {
      Operation_Executed_Server_1->Mark() = 0; 
   }else
   {
      Operation_Executed_Server_2->Mark() = 0; 
   }

   Operation_Executed_Client->Mark() = 1;
}else
{
	/* The faster server's response should be sent to the client as no exceptions have been raised */
	if(Server_ID==1)
	{
		Operation_Executed_Server_1->Mark() = 0;
	
	}else
	{
		Operation_Executed_Server_2->Mark() = 0;
	}

	if(Server_ID==1)
	{
		Server_1_Waiting_For_Client->Mark() = 1;		
	
	}else if(Server_ID==2)
	{
		Server_2_Waiting_For_Client->Mark() = 1;
	
	}else
	{
		if(GV_debug_flag==1)
		{
			std::cerr << "DIDERO_PC:DivSQL.cpp:: Server_ID is set to the erroneous value of " << Server_ID << "!!!!!" << std::endl;
		}
	}
   
   Operation_Executed_Client->Mark() = 1;
}